
package org.netbeans.modules.asm.core.editor;

import org.netbeans.editor.BaseTokenID;
import org.netbeans.editor.TokenContext;
import org.netbeans.editor.TokenContextPath;

/**
 *
 * @author am204439
 */
public class AsmTokenContext extends TokenContext {
    
    public static final int INSTRUCTION_ID = 1;
    public static final int REGISTER_ID = 2;
    public static final int LABEL_ID = 3;
    public static final int SECTION_ID = 4;
    public static final int COLON_ID = 5;
    public static final int NUMBER_ID = 6;
    public static final int UNKNOWN_ID = 7;
    public static final int COMMENT_ID = 8;

    // Token-ids
    public static final BaseTokenID INSTRUCTION = 
            new BaseTokenID("instruction", INSTRUCTION_ID);
    public static final BaseTokenID REGISTER = 
            new BaseTokenID("register", REGISTER_ID);
    public static final BaseTokenID LABEL = 
            new BaseTokenID("label", LABEL_ID);
    public static final BaseTokenID SECTION = 
            new BaseTokenID("section", SECTION_ID);
    public static final BaseTokenID COLON = 
            new BaseTokenID("colon", COLON_ID);
    public static final BaseTokenID NUMBER = 
            new BaseTokenID("number", NUMBER_ID);
    public static final BaseTokenID UNKNOWN = 
            new BaseTokenID("unknown", UNKNOWN_ID);
    public static final BaseTokenID COMMENT = 
            new BaseTokenID("comment", COMMENT_ID);
       
    // Context instance declaration
    public static final AsmTokenContext context = new AsmTokenContext();
    public static final TokenContextPath contextPath = context.getContextPath();
    
  
    public AsmTokenContext() {
        super("asm-");    
        
         try {
            addDeclaredTokenIDs();
        } catch (Exception e) { 
            
        }
    }
    
}
