/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.dom;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import org.netbeans.jsstubsgenerator.stub.GeneratorUtils;
import org.netbeans.jsstubsgenerator.stub.Origin;
import org.netbeans.jsstubsgenerator.stub.StubObject;
import org.netbeans.jsstubsgenerator.stub.Type;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class ScreenInstanceGenerator {

    public static void generate(Map<String, StubObject> allStubs) throws IOException {
        // general definition
        StubObject screenInstance = new StubObject(Origin.DOM, "Screen", StubObject.GLOBAL);
        screenInstance.setPrune(true);
        screenInstance.setType(Type.OBJECT);
        screenInstance.setSummary("Returns a reference to the screen object associated with the window.<br>The screen object is a special object for inspecting properties of the screen on which the current window is being rendered.");

        // properties definition
        String[][] attributes = new String[][]{
            {"availTop", "Number", "Specifies the y-coordinate of the first pixel that is not allocated to permanent or semipermanent user interface features. "},
            {"availLeft", "Number", "Returns the first available pixel available from the left side of the screen."},
            {"availHeight", "Number", "Returns the amount of vertical space available to the window on the screen. "},
            {"availWidth", "Number", "Returns the amount of horizontal space in pixels available to the window. "},
            {"colorDepth", "Number", "Returns the color depth of the screen. "},
            {"height", "Number", "Returns the height of the screen in pixels. "},
            {"left", "Number", "Returns the distance in pixels from the left side of the main screen to the left side of the current screen. "},
            {"pixelDepth", "Number", "Returns the bit depth of the screen. "},
            {"top", "Number", "Returns the distance in pixels from the top side of the current screen. "},
            {"width", "Number", "Returns the width of the screen. "},
        };
        List<StubObject> generatedProperties = GeneratorUtils.generateProperties(Origin.DOM, attributes, "Screen", false);
        for (StubObject instanceProperty : generatedProperties) {
            screenInstance.putAttribute(instanceProperty);
        }

        allStubs.put("Screen", screenInstance);
    }

}
