/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.print;

import org.netbeans.jsstubsgenerator.stub.StubObject;

/**
 * Prints small structures in the jsDoc documentation.
 *
 * @author marfous
 */
public class JsProperty extends JsConstruct {

    boolean innerAttribute;
    String superClass;

    public JsProperty(StubObject stubObject, int nestedLevel, boolean innerAttribute, String superClass) {
        super(stubObject, nestedLevel);
        this.innerAttribute = innerAttribute;
        this.superClass = superClass;
    }

    private void begin(String propertyName) {
        if (innerAttribute) {
            if (stubObject.isStatic()) {
                if ("prototype".equals(propertyName) || returnsUndefined(stubObject)) {
                    jsBuilder.append(stubObject.getParent() + "." + propertyName + ";");
                } else if (superClass != null) {
                    jsBuilder.append(stubObject.getParent() + "." + propertyName + " = new " + superClass + "();");
                } else if (stubObject.getReturns() != null && !stubObject.getReturns().getType().isEmpty()) {
                    jsBuilder.append(stubObject.getParent() + "." + propertyName + " = new " + stubObject.getReturns().getType() + "();");
                } else {
                    jsBuilder.append(stubObject.getParent() + "." + propertyName + ";");
                }
            } else {
                if (returnsUndefined(stubObject)) {
                    jsBuilder.append(stubObject.getParent() + ".prototype." + propertyName + ";");
                } else if (!stubObject.getReturns().getType().isEmpty()) {
                    jsBuilder.append(stubObject.getParent() + ".prototype." + propertyName + " = new " + stubObject.getReturns().getType() + "();");
                } else {
                    jsBuilder.append(stubObject.getParent() + ".prototype." + propertyName + ";");
                }
            }
        } else {
            jsBuilder.append("var " + propertyName + ";");
        }
    }

    public String print() {
        appendDoc(new DocSummary(stubObject, nestedLevel));
        begin(stubObject.getName());
        return jsBuilder.toString();
    }

    private boolean returnsUndefined(StubObject stubObject) {
        if (stubObject.getReturns() != null && !stubObject.getReturns().getType().isEmpty()) {
            return stubObject.getReturns().getType().equals("undefined");
        }
        return false;
    }

}
