/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.server.uihandler.bugs;

import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.persistence.EntityManager;
import org.netbeans.modules.exceptions.entity.Directuser;
import org.netbeans.modules.exceptions.entity.Exceptions;
import org.netbeans.modules.exceptions.entity.Nbuser;
import org.netbeans.modules.exceptions.entity.Nbversion;
import org.netbeans.modules.exceptions.entity.Slowness;
import org.netbeans.modules.exceptions.entity.Submit;
import org.netbeans.modules.exceptions.utils.PersistenceUtils;
import org.netbeans.server.uihandler.api.Issue;
import org.netbeans.server.uihandler.api.bugs.BugReporter;
import org.netbeans.server.uihandler.api.bugs.BugReporterFacade;
import org.netbeans.server.uihandler.api.bugs.BugTrackerInsertionFilter;
import org.netbeans.server.uihandler.api.bugs.BugTrackerInsertionFilterProvider;
import org.openide.util.lookup.ServiceProvider;

/**
 * Note: this is obsolete code - probably to be removed. As discussed it won't be used for netbeans/bugzilla 
 * exception reporting, it is not maintained.
 * 
 * TODO: static vs. nonstatic bordel. Filter Classy su static a furt volaju getInstance() - uplne sa mi to nepaci.
 * TODO: Je tu nejake napojenie - v IZInsertion(uihandlerserver - tj. privatny non-api kod) je kod pre IssueZillaInsertionRequest, 
 *       ktory sa odkazuje na tie iste konstanty ako pouzivaju niektore filtre. 
 * 
 * @author jlehotsky
 */
//@ServiceProvider(service = BugTrackerInsertionFilterProvider.class)
public class BugzillaInsertionFilterProvider implements BugTrackerInsertionFilterProvider {

    private static final Logger LOG = Logger.getLogger(BugzillaInsertionFilterProvider.class.getName());
    
    private static FilterMap filters;
    private static FilterMap reopenFilters;
    private static Long duplicatesNo;
    private static BugReporterFacade bugReporter;

    // TODO: These are duplicates from IZInsertion
    private static final int MESSAGE_AMOUNT = 1;
    private static final int MESSAGE_2_AMOUNT = 2;
    private static final int P2_PRIORITY_AMOUNT = 6;
    private static final int P1_PRIORITY_AMOUNT = 10;
    // End of duplicates

    private static final long MINIMAL_REPORT_TIME = 20000; // 20s
    private static final String OBSOLETE_VERSIONS = "7.1";
    
    private static final BugzillaInsertionFilterProvider instance = new BugzillaInsertionFilterProvider();
    
    public static BugzillaInsertionFilterProvider getInstance() {
        return instance;
    }

    public Long getDuplicatesNo() {
        if (duplicatesNo == null) {
            duplicatesNo = getVariable("duplicatesNo", Long.class);// NOI18N
        }
        return duplicatesNo;
    }

    public void setBugReporter(BugReporterFacade bugReporter) {
        this.bugReporter = bugReporter;
    }

    private static class FilterMap {
        private Map<Class, BugTrackerInsertionFilter[]> mapa = new HashMap<Class, BugTrackerInsertionFilter[]>();

        <Q extends Submit> void put(Class<Q> cls, BugTrackerInsertionFilter<Q>[] filters){
            mapa.put(cls, filters);
        }

        <Q extends Submit> BugTrackerInsertionFilter<Q>[] get(Class<Q> cls){
            return (BugTrackerInsertionFilter<Q>[]) mapa.get(cls);
        }

    }
    
    public <T extends Submit> BugTrackerInsertionFilter<T>[] getFilters(Class<T> clazz) {
        if (filters == null) {
            synchronized (BugzillaInsertionFilterProvider.class) {
                filters = new FilterMap();
                BugTrackerInsertionFilter<Exceptions>[] excFilters = new BugTrackerInsertionFilter[]{
                    // TODO make JDev implementation of OldVersionsFilter
//                new OldVersionsFilter(),
                new EmptyStacktraceFilter(),
                new IncorrectComponentFilter<Exceptions>(),
                new IssueClosedFilter<Exceptions>(),// first priority
//                new ManyDuplicatesFromOneUserFilter<Exceptions>(),
                new DirectUserFilter<Exceptions>(),
                new DirectComponentFilter<Exceptions>(),
                new NoClassDefFoundFilter(),
                new ExceptionClassNameFilter(),
                new DuplicatesNoFilter<Exceptions>(),
                new ManyDuplicatesFilter<Exceptions>(),
                new AddToCCFilter<Exceptions>(),
                };
                filters.put(Exceptions.class, excFilters);
                BugTrackerInsertionFilter<Slowness>[] slownFilters = new BugTrackerInsertionFilter[]{
                new OldVersionsFilter(),
                new OldReportsFilter<Slowness>(),
                new IncorrectComponentFilter<Slowness>(),
                new IssueClosedFilter<Slowness>(),// first priority
                new ManyDuplicatesFromOneUserFilter<Slowness>(),
                new LongTimeSlownessFilter(),
                new DuplicatesNoFilter<Slowness>(),
                new AddToCCFilter<Slowness>(),
                };
                filters.put(Slowness.class, slownFilters);
            }
        }
        return filters.get(clazz);
    }
    
    public <T extends Submit> BugTrackerInsertionFilter<T>[] getReopenFilters(Class<T> clazz) {
        if (reopenFilters == null) {
            synchronized (BugzillaInsertionFilterProvider.class) {
                reopenFilters = new FilterMap();
                BugTrackerInsertionFilter<Exceptions>[] excFilters = new BugTrackerInsertionFilter[]{
                new OldVersionsFilter(),
                new EmptyStacktraceFilter(),
                new IncorrectComponentFilter<Exceptions>(),
                };
                reopenFilters.put(Exceptions.class, excFilters);
                BugTrackerInsertionFilter<Slowness>[] slownFilters = new BugTrackerInsertionFilter[]{
                new OldVersionsFilter(),
                new OldReportsFilter<Slowness>(),
                new IncorrectComponentFilter<Slowness>(),
                };
                reopenFilters.put(Slowness.class, slownFilters);
            }
        }
        return reopenFilters.get(clazz);
    }


    private static Date OLD_REPORTS_DATE = new Date("10/01/09");
    
    private static class DuplicatesNoFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Submit exc) {
            int duplicates = exc.getReportId().getDuplicates(em);
            if ((duplicates > getInstance().getDuplicatesNo() && !exc.getReportId().isInIssuezilla())){
                return BugTrackerInsertionFilter.InsertionResult.INSERT;
            }
            if ((duplicates > getInstance().getDuplicatesNo()) && (duplicates < getInstance().getDuplicatesNo() + 3)) {
                return BugTrackerInsertionFilter.InsertionResult.ATTACHMENT;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }
    
    public static class DirectComponentFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        private static final String[] directlyInsertedComponents = new String[]{
            "cnd"
        };
        
        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            if (exc.getReportId().isInIssuezilla() || isGuest(exc.getNbuserId())) {
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            String component = exc.getReportId().getComponent();
            for (String c : directlyInsertedComponents) {
                if (c.equals(component)){
                    return BugTrackerInsertionFilter.InsertionResult.INSERT;
                }
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }
    
    private static class ExceptionClassNameFilter implements BugTrackerInsertionFilter<Exceptions> {
        private static final Class[] directlyInsertedClasses = new Class[]{
            NullPointerException.class,
            OutOfMemoryError.class,
            AssertionError.class,
            MissingResourceException.class,
            IllegalArgumentException.class
        };

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Exceptions exc) {
            if (exc.getReportId().isInIssuezilla() || isGuest(exc.getNbuserId())) {
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            String className = exc.getStacktrace().getClass1();
            for (Class directClass : directlyInsertedClasses) {
                if (className.contains(directClass.getSimpleName())){
                    return BugTrackerInsertionFilter.InsertionResult.INSERT;// NOI18N
                }
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class NoClassDefFoundFilter implements BugTrackerInsertionFilter<Exceptions> {
        private static final Class[] CLASS_LOADING_CLASSES = new Class[]{
            NoClassDefFoundError.class,
            ClassNotFoundException.class
        };

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Exceptions exc) {
            String className = exc.getStacktrace().getClass1();
            for (Class classLoadingErrorClass : CLASS_LOADING_CLASSES) {
                if (className.contains(classLoadingErrorClass.getSimpleName())){
                    int duplicates = exc.getReportId().getDuplicates(em);
                    if (duplicates < getInstance().getDuplicatesNo().intValue()){
                        return BugTrackerInsertionFilter.InsertionResult.CANCEL;
                    }
                }
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class DirectUserFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            Object object = exc.getNbuserId().getName();
            Map<String, Object> params = Collections.singletonMap("name", object);
            List<Directuser> directUsers = PersistenceUtils.executeNamedQuery(em, "Directuser.findByName", params, Directuser.class);
            if (directUsers.size() > 0) {
                if (exc.getReportId().isInIssuezilla()){
                    return BugTrackerInsertionFilter.InsertionResult.ATTACHMENT;
                }else{
                    return BugTrackerInsertionFilter.InsertionResult.INSERT;
                }
            } else {
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
        }
    }

    private static class IssueClosedFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            if (!exc.getReportId().isInIssuezilla()){
                LOG.fine("Not in issuezilla");
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            Integer issueId = exc.getReportId().getIssueId();
            Issue issue = bugReporter.getIssue(issueId);
            if ((issue == null) || (!issue.isOpen())) {
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class ManyDuplicatesFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T submit) {
            if (!submit.getReportId().isInIssuezilla()){
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            Issue issue = bugReporter.getIssue(submit.getReportId().getIssueId());
            if (issue == null || (!issue.isOpen())) {
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            int duplicatesCount = submit.getReportId().getDuplicates(em);
            int amount = getInstance().getDuplicatesAmount(duplicatesCount);
            if (duplicatesCount % getInstance().getDuplicatesNo() == 0){
                if ((amount == MESSAGE_AMOUNT) || (amount == MESSAGE_2_AMOUNT) || (amount == P2_PRIORITY_AMOUNT)) {
                    return BugTrackerInsertionFilter.InsertionResult.INCREASE_PRIORITY;
                }
                if ((amount > 0) && (amount % P1_PRIORITY_AMOUNT) == 0){
                    return BugTrackerInsertionFilter.InsertionResult.INCREASE_PRIORITY;
                }
            }

            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }

    }

    private static class ManyDuplicatesFromOneUserFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            Nbuser user = exc.getNbuserId();
            int duplicates = exc.getReportId().getDuplicatesFromOneUser(em, user);
            if (duplicates > 3) {
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    public static class AddToCCFilter<T extends Submit> implements BugTrackerInsertionFilter<T>{

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            if (exc.getReportId().isInIssuezilla() && !isGuest(exc.getNbuserId())){
                Issue issue = bugReporter.getIssue(exc.getReportId().getIssueId());
                if ((issue != null) && (!exc.getNbuserId().getName().equals(issue.getReporter())) && (issue.isOpen())){
                    return BugTrackerInsertionFilter.InsertionResult.ADDTOCC;
                }
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class IncorrectComponentFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {
        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Submit exc) {
            if (Arrays.asList(Submit.generatedComponents).contains(exc.getReportId().getComponent())){
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class EmptyStacktraceFilter implements BugTrackerInsertionFilter<Exceptions> {
        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Exceptions exc) {
            if (exc.getRelevantCause().getLineCollection().isEmpty()){
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    
    // (TODO in JDev copy-paste of this: copy filtering business logic for old versions from current jdev server
    private static class OldVersionsFilter implements BugTrackerInsertionFilter<Submit> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Submit sbm) {
            String versionNumber = sbm.getLogfileId().getProductVersionId().getNbversionId().getVersionNumber();
            if (versionNumber != null
                    && (!versionNumber.equals(Nbversion.DEV_VERSION))
                    && versionNumber.compareTo(OBSOLETE_VERSIONS) <= 0) {
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class LongTimeSlownessFilter implements BugTrackerInsertionFilter<Slowness> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, Slowness slow) {
            if ((slow.getActionTime() > MINIMAL_REPORT_TIME)
                    && (slow.getReportId().getDuplicates(em) > 1)
                    && (!slow.getReportId().isInIssuezilla())) {
                return BugTrackerInsertionFilter.InsertionResult.INSERT;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static class OldReportsFilter<T extends Submit> implements BugTrackerInsertionFilter<T> {

        public BugTrackerInsertionFilter.InsertionResult isInsertable(EntityManager em, T exc) {
            if (exc.getReportdate() == null){
                return BugTrackerInsertionFilter.InsertionResult.NONE;
            }
            if (!exc.isBuildNewerThan(OLD_REPORTS_DATE)){
                return BugTrackerInsertionFilter.InsertionResult.CANCEL;
            }
            return BugTrackerInsertionFilter.InsertionResult.NONE;
        }
    }

    private static boolean isGuest(Nbuser user){
        return isGuest(user.getName());
    }

    // TODO: Copied from Utils inside uihandlerserver (non-public)
    private static boolean isGuest(String userName){
        return BugReporter.GUEST_USER.equals(userName);
    }

    // TODO: copied from Utils inside uihnadlerserver (non-public)
    // TODO: logging commented as we don't hold reference for LogsManager
    public static <T> T getVariable(String name, Class<T> type) {
        try {
            Context initCtx = new InitialContext();
            Context c = (Context) initCtx.lookup("java:comp/env"); // NOI18N
            c = (Context)c.lookup("analytics"); // NOI18N
            return type.cast(c.lookup(name));
        } catch (NamingException ex) {
            /*LogsManager.LOG.log(Level.WARNING, "no env variable for " + name, ex);
            printContext("", null);*/
            return null;
        } catch (ClassCastException ex) {
            /*LogsManager.LOG.log(Level.WARNING, "wrong env variable for " + name + " we need " + type.getName(), ex);*/
            return null;
        }
    }


    // TODO: Copied from IZInsertion
    private int getDuplicatesAmount(int duplicatesCount) {
        return duplicatesCount / getDuplicatesNo().intValue();
    }
    
    // *** ONLY FOR TEST ***
    public static void setOldReportsDate(Date date){
        OLD_REPORTS_DATE = date;
    }
    
    public static void setDuplicatesNo(Long duplicates) {
        duplicatesNo = duplicates;
    }
}
