/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.modules.exceptions.entity;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import org.openide.util.NbBundle;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
@Entity
@Table(name = "build_info")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "BuildInfo.findAll", query = "SELECT b FROM BuildInfo b"),
    @NamedQuery(name = "BuildInfo.findById", query = "SELECT b FROM BuildInfo b WHERE b.id = :id"),
    @NamedQuery(name = "BuildInfo.findByVcs", query = "SELECT b FROM BuildInfo b WHERE b.vcs = :vcs"),
    @NamedQuery(name = "BuildInfo.findByIdentificator", query = "SELECT b FROM BuildInfo b WHERE b.identificator = :identificator"),
    @NamedQuery(name = "BuildInfo.findByBuildDate", query = "SELECT b FROM BuildInfo b WHERE b.buildDate = :buildDate")})
public class BuildInfo implements Serializable {
    public enum Vcs {
        HG,
        ADE,
        GIT,
        NONE;
        
        public static Vcs fromString(String s) {
            for (Vcs v : Vcs.values()) {
                if (v.toString().equalsIgnoreCase(s)) {
                    return v;
                }
            }
            return NONE;
            
        }
    }
    
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ID")
    private Integer id;
    @Column(name = "VCS")
    @Enumerated(EnumType.ORDINAL)
    private Vcs vcs;
    @Column(name = "IDENTIFICATOR")
    private String identificator;
    @Column(name = "BUILD_DATE")
    @Temporal(TemporalType.DATE)
    private Date buildDate;
    @Column(name = "VERSION")
    private String version;
    @OneToMany(mappedBy = "buildId")
    private Collection<Submit> exceptionsCollection;
    

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public BuildInfo() {
    }

    public BuildInfo(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Vcs getVcs() {
        return vcs;
    }

    public void setVcs(Vcs vcs) {
        this.vcs = vcs;
    }

    public String getIdentificator() {
        return identificator;
    }

    public void setIdentificator(String identificator) {
        this.identificator = identificator;
    }
    
    public String getIdentificatorName() {
        switch(getVcs()) {
            case ADE: return NbBundle.getMessage(BuildInfo.class, "LBL_ADE");
            case HG: return NbBundle.getMessage(BuildInfo.class, "LBL_HG");
            case GIT: return NbBundle.getMessage(BuildInfo.class, "LBL_GIT");
        }
        return NbBundle.getMessage(BuildInfo.class, "LBL_DEFAULT");
    }

    public Date getBuildDate() {
        return buildDate;
    }

    public void setBuildDate(Date buildDate) {
        this.buildDate = buildDate;
    }

    @XmlTransient
    public Collection<Submit> getExceptionsCollection() {
        return exceptionsCollection;
    }

    public void setExceptionsCollection(Collection<Submit> exceptionsCollection) {
        this.exceptionsCollection = exceptionsCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof BuildInfo)) {
            return false;
        }
        BuildInfo other = (BuildInfo) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "javaapplication1.newpackage.BuildInfo[ id=" + id + " ]";
    }
    
}
