/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.modules.exceptions.entity;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
@Entity
@Table(name = "package_mapping")
@NamedQueries({
    @NamedQuery(name = "PackageMapping.findAll", query = "SELECT p FROM PackageMapping p"),
    @NamedQuery(name = "PackageMapping.findByPackage1", query = "SELECT p FROM PackageMapping p WHERE p.package1 = :package1"),
    @NamedQuery(name = "PackageMapping.findByComponent", query = "SELECT p FROM PackageMapping p WHERE p.component = :component"),
    @NamedQuery(name = "PackageMapping.findBySubcomponent", query = "SELECT p FROM PackageMapping p WHERE p.subcomponent = :subcomponent"),
    @NamedQuery(name = "PackageMapping.findByProduct", query = "SELECT p FROM PackageMapping p WHERE p.product = :product")})
public class PackageMapping implements Serializable, Comparable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "PACKAGE")
    private String package1;
    @Column(name = "COMPONENT")
    private String component;
    @Column(name = "SUBCOMPONENT")
    private String subcomponent;
    @Column(name = "PRODUCT")
    private Integer product;

    public PackageMapping() {
    }

    public PackageMapping(String package1) {
        this.package1 = package1;
    }

    public String getPackage() {
        return package1;
    }

    public void setPackage(String package1) {
        this.package1 = package1;
    }

    public String getComponent() {
        return component;
    }

    public void setComponent(String component) {
        this.component = component;
    }

    public String getSubcomponent() {
        return subcomponent;
    }

    public void setSubcomponent(String subcomponent) {
        this.subcomponent = subcomponent;
    }

    public Integer getProduct() {
        return product;
    }

    public void setProduct(Integer product) {
        this.product = product;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (package1 != null ? package1.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PackageMapping)) {
            return false;
        }
        PackageMapping other = (PackageMapping) object;
        if ((this.package1 == null && other.package1 != null) || (this.package1 != null && !this.package1.equals(other.package1))) {
            return false;
        }
        return true;
    }

    @Override
    public int compareTo(Object o) {
        if (o instanceof PackageMapping) {
            return package1.compareTo(((PackageMapping) o).getPackage());
        }
        return -1;
    }

    
}
