/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.server.uihandler.api.bugs;

import java.util.Collection;
import java.util.Map;
import org.netbeans.server.services.beans.Components;
import org.netbeans.server.services.beans.Mappings;
import org.netbeans.server.uihandler.api.Issue;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
public interface BugConnector {
    
    public Issue getIssue(int id);

    public Collection<Integer> filterOpen(Collection<Integer> ids);

    public Components getComponents();
    
    public Map<String, String> getComponentsForProduct(int productId);
    
    public Map<String, String> getSubcomponents(int projectId, String component);
    
    public Map<Integer, String> getProducts();

    public Mappings getMappings();
    
    public String getBugURL(int id);
    
    public String getURLPrefix();
    
    public Stats getFixedCount(final Collection<Integer> list);
    
    public interface Stats {

        public int getFixed();
        
        public void setFixed(int fixed);

        public int getResolved();

        public void setResolved(int resolved);
        
    }

}
