/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.server.uihandler.api.bugs;

import org.netbeans.modules.exceptions.entity.Report;
import javax.persistence.EntityManager;

/**
 * Provider that allows categorization
 * 
 * @author jlehotsky
 */
public interface BugTrackerCategorizer {
   
    /**
     * Checks whether this particular issue already has a report.
     * 
     * It is supposed to updates report and exception tables in db on the fly
     */
    Report matchToReport(EntityManager em, int loggedSubmitId, Throwable thrown, int apiMark, String reportType);
    
    /**
     * Checks whether this particular testname associated issue already has a report.
     * 
     * It is supposed to updates report and exception tables in db on the fly
     */
    Report matchToReport(EntityManager em, int loggedSubmitId, Throwable thrown, String testName, String reportType);
 
    /**
     * Checks whether this particular issue already has a report.
     * 
     * This ones checks the open issue for the purpose of reopen
     */
    Report matchOpenToReport(EntityManager em, int loggedSubmitId, Throwable mockThrowable, String testName, String reportType);
    
    /**
     * Indicates check for a package name if it is excluded from matching algorithm.
     * 
     * @param className    Fully qualified name of the class
     * @return             true iff algorithm excludes this package name from matching
     */
    boolean isPackageExcluded(String className);
}
