/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.server.uihandler.api.bugs;

import org.openide.util.Lookup;

/**
 *
 * @author jlehotsky
 */
public class BugTrackerProvidersFactory {

    private static BugTrackerProvidersFactory instance;
    
    private BugTrackerReopenChecker reopenCheckerMockup = null;
        
    static {
        instance = new BugTrackerProvidersFactory();
    }
    
    public static BugTrackerProvidersFactory getInstance() {
        return instance;
    }
    
    // For the purposes of unit testing
    public void setReopenCheckerMockup(BugTrackerReopenChecker reopenCheckerMockup) {
        this.reopenCheckerMockup = reopenCheckerMockup;
    }
    
    public BugTrackerInsertionFilterProvider getInsertionFilterProvider() {
        BugTrackerInsertionFilterProvider reporter = Lookup.getDefault().lookup(BugTrackerInsertionFilterProvider.class);
        
        if (reporter == null) {
            return new DefaultInsertionFilterProvider();
        }
        
        return reporter;
        
    }
    
    public BugTrackerCategorizer getCategorizer(String reportType) {
        BugTrackerCategorizer categorizer = Lookup.getDefault().lookup(BugTrackerCategorizerFactory.class)
            .getCategorizer(reportType);
        
        return categorizer;
        
    }
      
    public BugTrackerInsertionDelayProvider getInsertionTimeoutProvider(BugTrackerInsertionDelayProvider fallback) {
        BugTrackerInsertionDelayProvider timeouter = Lookup.getDefault().lookup(BugTrackerInsertionDelayProvider.class);
        
        if (timeouter == null) {
            return fallback;
        }
        
        return timeouter;
        
    }
    
    public BugTrackerReopenChecker getReopenChecker(BugTrackerReopenChecker fallback) {

        if (reopenCheckerMockup != null) {
            return reopenCheckerMockup;
        }
        
        BugTrackerReopenChecker reopenChecker = Lookup.getDefault().lookup(BugTrackerReopenChecker.class);
        
        if (reopenChecker == null) {
            return fallback;
        }
        
        return reopenChecker;
        
    }        

    
    
}
