/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.netbeans.server.uihandler.api.bugs;

import java.util.logging.Logger;
import org.netbeans.modules.exceptions.entity.Submit;

/**
 *
 * @author jlehotsky
 */
public interface BugTrackerReopenChecker {
    
    /**
     * This method should provide business logic for reopening or not-reopening
     * given bug for this submit. 
     * 
     * Handle call to reopen via callback (in the case new database insertion is needed) 
     * or may call direct reopen of a bug. If it invokes any reopen action, returns true.
     * Returns false otherwise.
     * 
     * @param sbmt       Current submit. If applicable
     * @param callback   Callback that contains handles for DBInsertion reopen handling
     * @return           true if reopen was invoked.
     */
     public boolean checkDuplicateReportForReopen(Submit sbmt, ReopenCallback callback);

}
