package org.netbeans.modules.exceptions.entity;

import static org.junit.Assert.*;
import org.netbeans.server.uihandler.api.SubmitInterface;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
public class SubmitTest {
    
    public SubmitTest() {
    }
    
    
    public void testGetVersionNumber() {
        Exceptions sub = new Exceptions();
        Logfile lf = new Logfile();
        ProductVersion pv = new ProductVersion();
        Nbversion nbv = new Nbversion();
        sub.setLogfileId(lf);
        lf.setProductVersionId(pv);
        pv.setNbversionId(nbv);
        nbv.setLongVersion("NetBeans IDE 6.0 beta");
        SubmitInterface si = sub.getSubmit(null);
        
        
        String result = si.getBugzillaVersion();
        assertEquals("6.0", result);
        nbv.setLongVersion("NetBeans IDE 6.0");
        result = si.getBugzillaVersion();
        assertEquals(result, "6.0", result);
        nbv.setLongVersion("NetBeans IDE 6.0.1 RC1");
        result = si.getBugzillaVersion();
        assertEquals("6.0.1", result);
        nbv.setLongVersion("NetBeans IDE 6.5.1");
        result = si.getBugzillaVersion();
        assertEquals("6.5", result);
        nbv.setLongVersion("NetBeans IDE 6.5");
        result = si.getBugzillaVersion();
        assertEquals("6.5", result);
        nbv.setLongVersion("NetBeans IDE 6.7");
        result = si.getBugzillaVersion();
        assertEquals("6.7", result);
        nbv.setLongVersion("NetBeans IDE Dev");
        result = si.getBugzillaVersion();
        assertEquals(Nbversion.DEFAULT_VERSION, result);
    }
}