-- MySQL dump 10.10
--
-- Host: localhost    Database: exceptions
-- ------------------------------------------------------
-- Server version	5.0.18

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
CREATE TABLE `comment` (
  `ID` int(11) NOT NULL default '0',
  `EXCEPTION_ID` int(11) NOT NULL default '0',
  `NBUSER_ID` int(11) default NULL,
  `COMMENT` varchar(1000) default NULL,
  `COMMENT_DATE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`),
  KEY `EXCEPTION_ID` (`EXCEPTION_ID`),
  KEY `NBUSER_ID` (`NBUSER_ID`),
  CONSTRAINT `comment_ibfk_2` FOREIGN KEY (`NBUSER_ID`) REFERENCES `nbuser` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `directuser`
--

DROP TABLE IF EXISTS `directuser`;
CREATE TABLE `directuser` (
  `NAME` varchar(30) NOT NULL,
  `MESSAGE_PREFIX` varchar(30) default NULL,
  PRIMARY KEY  (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `duplicates_log`
--

DROP TABLE IF EXISTS `duplicates_log`;
CREATE TABLE `duplicates_log` (
  `ID` int(11) NOT NULL,
  `EXCEPTIONS` int(11) NOT NULL,
  `OLD_REPORT` int(11) NOT NULL,
  `CHANGE_DATE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`),
  KEY `OLD_REPORT` (`OLD_REPORT`),
  KEY `EXCEPTIONS` (`EXCEPTIONS`),
  CONSTRAINT `duplicates_log_ibfk_1` FOREIGN KEY (`OLD_REPORT`) REFERENCES `report` (`ID`),
  CONSTRAINT `duplicates_log_ibfk_2` FOREIGN KEY (`EXCEPTIONS`) REFERENCES `exceptions` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `exceptions`
--

DROP TABLE IF EXISTS `exceptions`;
CREATE TABLE `exceptions` (
  `ID` int(11) NOT NULL default '0',
  `SUMMARY` varchar(200) default NULL,
  `STACKTRACE` int(11) default NULL,
  `REPORTDATE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `NBUSER_ID` int(11) default NULL,
  `BUILD` decimal(14,0) default NULL,
  `STATUS` int(11) default NULL,
  `LOGFILE_ID` int(11) default NULL,
  `REPORT_ID` int(11) default NULL,
  `VM_ID` int(11) default NULL,
  `OPERATINGSYSTEM_ID` int(11) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `STACKTRACE` (`STACKTRACE`),
  KEY `NBUSER_ID` (`NBUSER_ID`),
  KEY `LOGFILE_ID` (`LOGFILE_ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `VM_ID` (`VM_ID`),
  KEY `OPERATINGSYSTEM_ID` (`OPERATINGSYSTEM_ID`),
  CONSTRAINT `exceptions_ibfk_1` FOREIGN KEY (`NBUSER_ID`) REFERENCES `nbuser` (`ID`),
  CONSTRAINT `exceptions_ibfk_2` FOREIGN KEY (`STACKTRACE`) REFERENCES `stacktrace` (`ID`),
  CONSTRAINT `exceptions_ibfk_4` FOREIGN KEY (`LOGFILE_ID`) REFERENCES `logfile` (`ID`),
  CONSTRAINT `exceptions_ibfk_5` FOREIGN KEY (`REPORT_ID`) REFERENCES `report` (`ID`),
  CONSTRAINT `exceptions_ibfk_6` FOREIGN KEY (`VM_ID`) REFERENCES `vm` (`ID`),
  CONSTRAINT `exceptions_ibfk_7` FOREIGN KEY (`OPERATINGSYSTEM_ID`) REFERENCES `operatingsystem` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `hashcodes`
--

DROP TABLE IF EXISTS `hashcodes`;
CREATE TABLE `hashcodes` (
  `CODE` int(11) default NULL,
  `EXCEPTIONID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`EXCEPTIONID`),
  KEY `HASHCODES_CODE` (`CODE`),
  CONSTRAINT `hashcodes_ibfk_1` FOREIGN KEY (`EXCEPTIONID`) REFERENCES `exceptions` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `innocentclass`
--

DROP TABLE IF EXISTS `innocentclass`;
CREATE TABLE `innocentclass` (
  `CLASSNAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`CLASSNAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `issue_build`
--

DROP TABLE IF EXISTS `issue_build`;
CREATE TABLE `issue_build` (
  `ISSUE_NUMBER` int(11) NOT NULL,
  `BUILD_NUMBER` bigint(20) default NULL,
  PRIMARY KEY  (`ISSUE_NUMBER`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `jarfile`
--

DROP TABLE IF EXISTS `jarfile`;
CREATE TABLE `jarfile` (
  `ID` int(11) NOT NULL default '0',
  `NAME` varchar(200) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`),
  KEY `JARFILEINDEX` (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `line`
--

DROP TABLE IF EXISTS `line`;
CREATE TABLE `line` (
  `STACKTRACE_ID` int(11) NOT NULL default '0',
  `METHOD_ID` int(11) NOT NULL default '0',
  `LINENUMBER` int(11) NOT NULL default '0',
  `LINE_ORDER` int(11) NOT NULL default '0',
  `JARFILE_ID` int(11) default NULL,
  `LINE_HASHCODE` int(11) default NULL,
  `GENERATECOMPONENT` int(11) default NULL,
  PRIMARY KEY  (`STACKTRACE_ID`,`LINENUMBER`,`METHOD_ID`,`LINE_ORDER`),
  KEY `METHOD_ID` (`METHOD_ID`),
  KEY `JARFILE_ID` (`JARFILE_ID`),
  KEY `LINE_HASHCODE` (`LINE_HASHCODE`),
  CONSTRAINT `line_ibfk_1` FOREIGN KEY (`STACKTRACE_ID`) REFERENCES `stacktrace` (`ID`),
  CONSTRAINT `line_ibfk_2` FOREIGN KEY (`METHOD_ID`) REFERENCES `method` (`ID`),
  CONSTRAINT `line_ibfk_3` FOREIGN KEY (`JARFILE_ID`) REFERENCES `jarfile` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `logfile`
--

DROP TABLE IF EXISTS `logfile`;
CREATE TABLE `logfile` (
  `ID` int(11) NOT NULL,
  `NBUSER_ID` int(11) default NULL,
  `PRODUCT_VERSION_ID` int(11) default NULL,
  `IP` decimal(12,0) default NULL,
  `buildnumber` decimal(14,0) default NULL,
  `USERDIR` varchar(255) NOT NULL,
  `UPLOAD_NUMBER` int(11) NOT NULL,
  `DATE_CREATED` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `CHANGESET` bigint(20) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `USERDIR` (`USERDIR`,`UPLOAD_NUMBER`),
  KEY `NBUSER_ID` (`NBUSER_ID`),
  KEY `PRODUCT_VERSION_ID` (`PRODUCT_VERSION_ID`),
  KEY `GET_LOG_INFO` (`USERDIR`,`UPLOAD_NUMBER`),
  CONSTRAINT `logfile_ibfk_1` FOREIGN KEY (`NBUSER_ID`) REFERENCES `nbuser` (`ID`),
  CONSTRAINT `logfile_ibfk_2` FOREIGN KEY (`PRODUCT_VERSION_ID`) REFERENCES `product_version` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `logfileparsed`
--

DROP TABLE IF EXISTS `logfileparsed`;
CREATE TABLE `logfileparsed` (
  `ID` int(11) NOT NULL,
  `STATISTIC` int(11) NOT NULL,
  `LOGFILE` int(11) NOT NULL,
  `REVISION` int(11) NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY `STATISTIC` (`STATISTIC`),
  KEY `LOGFILEPARSED_WITHOUTKEY` (`LOGFILE`,`STATISTIC`),
  CONSTRAINT `logfileparsed_ibfk_1` FOREIGN KEY (`LOGFILE`) REFERENCES `logfile` (`ID`),
  CONSTRAINT `logfileparsed_ibfk_2` FOREIGN KEY (`STATISTIC`) REFERENCES `statistic` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `mapping`
--

DROP TABLE IF EXISTS `mapping`;
CREATE TABLE `mapping` (
  `OLD_COMPONENT` varchar(50) NOT NULL default '',
  `OLD_SUBCOMPONENT` varchar(50) NOT NULL default '',
  `NEW_COMPONENT` varchar(50) default NULL,
  `NEW_SUBCOMPONENT` varchar(50) default NULL,
  PRIMARY KEY  (`OLD_COMPONENT`,`OLD_SUBCOMPONENT`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `method`
--

DROP TABLE IF EXISTS `method`;
CREATE TABLE `method` (
  `ID` int(11) NOT NULL default '0',
  `NAME` varchar(200) NOT NULL,
  `SOURCEJAR` int(11) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`),
  KEY `METHODINDEX` (`NAME`),
  KEY `SOURCEJAR` (`SOURCEJAR`),
  CONSTRAINT `method_ibfk_1` FOREIGN KEY (`SOURCEJAR`) REFERENCES `sourcejar` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `nbuser`
--

DROP TABLE IF EXISTS `nbuser`;
CREATE TABLE `nbuser` (
  `ID` int(11) NOT NULL default '0',
  `NAME` varchar(30) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`),
  KEY `NBUSERINDEX` (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `nbversion`
--

DROP TABLE IF EXISTS `nbversion`;
CREATE TABLE `nbversion` (
  `ID` int(11) NOT NULL,
  `VERSION` varchar(64) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `VERSION` (`VERSION`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `operatingsystem`
--

DROP TABLE IF EXISTS `operatingsystem`;
CREATE TABLE `operatingsystem` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(255) default NULL,
  `VERSION` varchar(64) default NULL,
  `ARCH` varchar(32) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`,`VERSION`,`ARCH`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `patch`
--

DROP TABLE IF EXISTS `patch`;
CREATE TABLE `patch` (
  `ID` int(11) NOT NULL,
  `PATCHNAME` varchar(30) default NULL,
  `MODULENAME` varchar(100) default NULL,
  `SPECVERSION` varchar(20) default NULL,
  `NBVERSION_ID` int(11) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `NBVERSION_ID` (`NBVERSION_ID`),
  CONSTRAINT `patch_ibfk_1` FOREIGN KEY (`NBVERSION_ID`) REFERENCES `nbversion` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `preferences`
--

DROP TABLE IF EXISTS `preferences`;
CREATE TABLE `preferences` (
  `ID` int(11) NOT NULL,
  `STATISTIC` int(11) default NULL,
  `LOGFILE` int(11) default NULL,
  `NAME` int(11) default NULL,
  `VALUE` int(11) default NULL,
  `DIRECT_VALUE` int(11) default NULL,
  `PREFIX` varchar(100) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `LOGFILE` (`LOGFILE`),
  KEY `STATISTIC` (`STATISTIC`),
  KEY `NAME` (`NAME`),
  KEY `VALUE` (`VALUE`),
  CONSTRAINT `preferences_ibfk_1` FOREIGN KEY (`LOGFILE`) REFERENCES `logfile` (`ID`),
  CONSTRAINT `preferences_ibfk_2` FOREIGN KEY (`STATISTIC`) REFERENCES `statistic` (`ID`),
  CONSTRAINT `preferences_ibfk_3` FOREIGN KEY (`NAME`) REFERENCES `prefname` (`ID`),
  CONSTRAINT `preferences_ibfk_4` FOREIGN KEY (`VALUE`) REFERENCES `prefvalue` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `prefname`
--

DROP TABLE IF EXISTS `prefname`;
CREATE TABLE `prefname` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(80) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`),
  KEY `PREFNAME_NAME` (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `prefset`
--

DROP TABLE IF EXISTS `prefset`;
CREATE TABLE `prefset` (
  `PREFNAME` int(11) NOT NULL default '0',
  `STATISTIC` int(11) NOT NULL default '0',
  `ITEM_INDEX` int(11) NOT NULL default '0',
  PRIMARY KEY  (`PREFNAME`,`STATISTIC`,`ITEM_INDEX`),
  KEY `STATISTIC` (`STATISTIC`),
  CONSTRAINT `prefset_ibfk_1` FOREIGN KEY (`PREFNAME`) REFERENCES `prefname` (`ID`),
  CONSTRAINT `prefset_ibfk_2` FOREIGN KEY (`STATISTIC`) REFERENCES `statistic` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `prefvalue`
--

DROP TABLE IF EXISTS `prefvalue`;
CREATE TABLE `prefvalue` (
  `ID` int(11) NOT NULL,
  `VALUE` varchar(8192) default NULL,
  PRIMARY KEY  (`ID`),
  KEY `PREFVALUE_VALUE` (`VALUE`(767))
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `product_version`
--

DROP TABLE IF EXISTS `product_version`;
CREATE TABLE `product_version` (
  `ID` int(11) NOT NULL,
  `NBVERSION_ID` int(11) default NULL,
  `PRODUCT_VERSION` varchar(255) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `PRODUCT_VERSION` (`PRODUCT_VERSION`),
  KEY `NBVERSION_ID` (`NBVERSION_ID`),
  CONSTRAINT `product_version_ibfk_1` FOREIGN KEY (`NBVERSION_ID`) REFERENCES `nbversion` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `report`
--

DROP TABLE IF EXISTS `report`;
CREATE TABLE `report` (
  `ID` int(11) NOT NULL,
  `COMPONENT` varchar(255) default NULL,
  `SUBCOMPONENT` varchar(255) default NULL,
  `ISSUE_ID` int(11) default NULL,
  `STATUS` int(11) default NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `report_comment`
--

DROP TABLE IF EXISTS `report_comment`;
CREATE TABLE `report_comment` (
  `ID` int(11) NOT NULL,
  `REPORT_ID` int(11) NOT NULL,
  `NBUSER_ID` int(11) NOT NULL,
  `COMMENT` varchar(1000) default NULL,
  `COMMENT_DATE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `NBUSER_ID` (`NBUSER_ID`),
  CONSTRAINT `report_comment_ibfk_1` FOREIGN KEY (`REPORT_ID`) REFERENCES `report` (`ID`),
  CONSTRAINT `report_comment_ibfk_2` FOREIGN KEY (`NBUSER_ID`) REFERENCES `nbuser` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `sequence`
--

DROP TABLE IF EXISTS `sequence`;
CREATE TABLE `sequence` (
  `SEQ_NAME` varchar(50) NOT NULL,
  `SEQ_COUNT` decimal(10,0) default NULL,
  PRIMARY KEY  (`SEQ_NAME`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `slowness`
--

DROP TABLE IF EXISTS `slowness`;
CREATE TABLE `slowness` (
  `ID` int(11) NOT NULL,
  `SUMMARY` varchar(200) default NULL,
  `REPORTDATE` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `ACTION_TIME` int(11) NOT NULL,
  `SUSPICIOUS_METHOD` int(11) NOT NULL,
  `LATEST_ACTION` varchar(200) default NULL,
  `NBUSER_ID` int(11) default NULL,
  `LOGFILE_ID` int(11) default NULL,
  `REPORT_ID` int(11) NOT NULL,
  `VM_ID` int(11) default NULL,
  `OPERATINGSYSTEM_ID` int(11) default NULL,
  `SLOWNESS_TYPE` varchar(30) default NULL,
  `FLAGS` int(11) default '0',
  PRIMARY KEY  (`ID`),
  KEY `NBUSER_ID` (`NBUSER_ID`),
  KEY `LOGFILE_ID` (`LOGFILE_ID`),
  KEY `REPORT_ID` (`REPORT_ID`),
  KEY `VM_ID` (`VM_ID`),
  KEY `SUSPICIOUS_METHOD` (`SUSPICIOUS_METHOD`),
  KEY `OPERATINGSYSTEM_ID` (`OPERATINGSYSTEM_ID`),
  CONSTRAINT `slowness_ibfk_1` FOREIGN KEY (`NBUSER_ID`) REFERENCES `nbuser` (`ID`),
  CONSTRAINT `slowness_ibfk_2` FOREIGN KEY (`LOGFILE_ID`) REFERENCES `logfile` (`ID`),
  CONSTRAINT `slowness_ibfk_3` FOREIGN KEY (`REPORT_ID`) REFERENCES `report` (`ID`),
  CONSTRAINT `slowness_ibfk_4` FOREIGN KEY (`VM_ID`) REFERENCES `vm` (`ID`),
  CONSTRAINT `slowness_ibfk_5` FOREIGN KEY (`SUSPICIOUS_METHOD`) REFERENCES `method` (`ID`),
  CONSTRAINT `slowness_ibfk_6` FOREIGN KEY (`OPERATINGSYSTEM_ID`) REFERENCES `operatingsystem` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `sourcejar`
--

DROP TABLE IF EXISTS `sourcejar`;
CREATE TABLE `sourcejar` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(200) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`),
  KEY `SOURCEINDEX` (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `sourcejar_mapping`
--

DROP TABLE IF EXISTS `sourcejar_mapping`;
CREATE TABLE `sourcejar_mapping` (
  `SOURCEJAR` varchar(200) NOT NULL,
  `COMPONENT` varchar(50) default NULL,
  `SUBCOMPONENT` varchar(100) default NULL,
  PRIMARY KEY  (`SOURCEJAR`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `stacktrace`
--

DROP TABLE IF EXISTS `stacktrace`;
CREATE TABLE `stacktrace` (
  `ID` int(11) NOT NULL default '0',
  `MESSAGE` varchar(1024) default NULL,
  `CLASS` varchar(1024) default NULL,
  `ANNOTATION` int(11) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `ANNOTATION` (`ANNOTATION`),
  CONSTRAINT `stacktrace_ibfk_1` FOREIGN KEY (`ANNOTATION`) REFERENCES `stacktrace` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `statistic`
--

DROP TABLE IF EXISTS `statistic`;
CREATE TABLE `statistic` (
  `ID` int(11) NOT NULL,
  `STATNAME` varchar(64) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `STATNAME` (`STATNAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `suspicious_method_mapping`
--

DROP TABLE IF EXISTS `suspicious_method_mapping`;
CREATE TABLE `suspicious_method_mapping` (
  `ORIGINAL_METHOD_NAME` varchar(100) NOT NULL,
  `MAPPED_METHOD_NAME` varchar(100) NOT NULL,
  PRIMARY KEY  (`ORIGINAL_METHOD_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Table structure for table `vm`
--

DROP TABLE IF EXISTS `vm`;
CREATE TABLE `vm` (
  `ID` int(11) NOT NULL,
  `NAME` varchar(255) default NULL,
  `SHORT_NAME` varchar(32) default NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `NAME` (`NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

