/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.web.action;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.netbeans.modules.exceptions.entity.Report;
import org.netbeans.web.EntityManagerFilter;

/**
 *
 * @author jlehotsky
 */
public class OverseeAction extends Action {
    private final static String SUCCESS = "success";
    
//    String queryStr = 
//        "select y.report_id,y.reportdate, y.identificator, report.reporttype from (\n"
//            + "select report_id, reportdate, identificator from (\n"
//                + "select exceptions.report_id, exceptions.reportdate, build_info.identificator from exceptions left join build_info on exceptions.build_id=build_info.id order by reportdate desc\n"
//            + ") x group by report_id\n"
//        + ") y left join report on y.report_id=report.id;\n";
//    
    String queryStr = 
        "select e.reportId, max(e.reportdate), e.buildId.identificator, e.buildId.version\n" +
        "  from Exceptions e\n" +
        "group by e.reportId";
    
    String exceptionsStr = 
        "select e from Exceptions e\n"
        + "where e.reportdate > :reportDateFrom and e.reportdate < :reportDateTo\n order by e.id desc";
    
    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        
        List<OverseeItem> items = new ArrayList<>();
        
        EntityManager em = (EntityManager) request.getAttribute(EntityManagerFilter.ENTITY_MANAGER);
        Query query = em.createQuery(queryStr);
        
        List<Object[]> results = query.getResultList();
        
        HashMap<String, Long> daysMap = new HashMap<>();
        
        for (Object[] result : results) {
            Report report = (Report)result[0];
            Timestamp timestamp = (Timestamp)result[1];
            String buildId = (String)result[2];
            
            if (report.getReportType() == null) {
                continue;
            }
            
            if ("JDEV".equals(report.getReportType())
                || "SRG".equals(report.getReportType()))
            {
                if (buildId.lastIndexOf("_") > 0) {
                    // In case a non-ade build is marked as JDEV or SRG
                    buildId = buildId.substring(0, buildId.lastIndexOf("_"));
                }
            }
            if ("DCS".equals(report.getReportType())) {
                buildId = (String)result[3];
            }

            // Java 7 version date differnece calculation:
            Date reportDate = new Date(timestamp.getTime());
            Calendar reportCal = new GregorianCalendar();
            reportCal.setTime(reportDate);
            
            Calendar nowCal = new GregorianCalendar();
                    
            reportCal.set(Calendar.HOUR_OF_DAY, 0);
            reportCal.set(Calendar.MINUTE, 0);
            reportCal.set(Calendar.SECOND, 0);
            reportCal.set(Calendar.MILLISECOND, 0);

            nowCal.set(Calendar.HOUR_OF_DAY, 0);
            nowCal.set(Calendar.MINUTE, 0);
            nowCal.set(Calendar.SECOND, 0);
            nowCal.set(Calendar.MILLISECOND, 0);

            long DST_ADJUSTMENT = 1 * 60 * 60 * 1000;
            long days = TimeUnit.MILLISECONDS.toDays(Math.abs(nowCal.getTimeInMillis() - reportCal.getTimeInMillis()) + DST_ADJUSTMENT);
            
            // Java 8 version date difference calculation:
//            LocalDate date = timestamp.toLocalDateTime().toLocalDate();
//            long days = ChronoUnit.DAYS.between(date, LocalDate.now());
            
            String key = report.getReportType() + buildId;
            
            if (!daysMap.containsKey(key)) {
                daysMap.put(key, days);
            } else {
                long originalDays = daysMap.get(key);
                if (days < originalDays) {
                    daysMap.put(key, days);
                }
            }
            
        }
        
        for (Map.Entry<String, Long> entry : daysMap.entrySet()) {
            if (entry.getKey().startsWith("JDEV")) {
                String branch = entry.getKey().substring(4);
                items.add(new OverseeItem("<a href=\"/reports/list.do?reportType=JDEV\">JDev IDE</a>", branch, entry.getValue()));                
            }
        }
        
        for (Map.Entry<String, Long> entry : daysMap.entrySet()) {
            if (entry.getKey().startsWith("SRG")) {
                String branch = entry.getKey().substring(3);
                items.add(new OverseeItem("<a href=\"/reports/list.do?reportType=SRG\">JDev SRG</a>", branch, entry.getValue()));                
            }
        }
        
        for (Map.Entry<String, Long> entry : daysMap.entrySet()) {
            if (entry.getKey().startsWith("DCS")) {
                String branch = entry.getKey().substring(3);
                items.add(new OverseeItem("<a href=\"/reports/list.do?reportType=DCS\">DCS</a>", branch, entry.getValue()));
            }
        }
        
        request.setAttribute("watchitems", items);
        
        request.setAttribute("exceptions0", queryExceptions(em,0));
        request.setAttribute("exceptions1", queryExceptions(em,-1));
        request.setAttribute("exceptions2", queryExceptions(em,-2));
        request.setAttribute("exceptions3", queryExceptions(em,-3));
        request.setAttribute("exceptions4", queryExceptions(em,-4));
        request.setAttribute("exceptions5", queryExceptions(em,-5));
        
        return mapping.findForward(SUCCESS);
    }
    
    private static void setParameter(Query query, String name, Object value) {
        if (value != null) {
            if (!(value instanceof String && value.toString().length() == 0)) {
                query.setParameter(name, value);
            }
        }
    }

    private Object queryExceptions(EntityManager em, int i) {
        Calendar toCal = new GregorianCalendar();
        toCal.add(Calendar.DATE, i);
        toCal.set(Calendar.HOUR_OF_DAY, 23);
        toCal.set(Calendar.MINUTE, 59);
        toCal.set(Calendar.SECOND, 59);
        toCal.set(Calendar.MILLISECOND, 999);

        Calendar fromCal = new GregorianCalendar();
        fromCal.add(Calendar.DATE, i);
        fromCal.set(Calendar.HOUR_OF_DAY, 0);
        fromCal.set(Calendar.MINUTE, 0);
        fromCal.set(Calendar.SECOND, 0);
        fromCal.set(Calendar.MILLISECOND, 0);
        
        Query query = em.createQuery(exceptionsStr);
        setParameter(query, "reportDateFrom", fromCal.getTime());
        setParameter(query, "reportDateTo", toCal.getTime());
        
        return query.getResultList();

    }
    
    public class OverseeItem {

        String category;
        String branch;
        long lastReportDays;

        public OverseeItem(String category, String branch, long lastReportDays) {
            this.category = category;
            this.branch = branch;
            this.lastReportDays = lastReportDays;
        }
        
        public String getCategory() {
            return category;
        }
        
        public String getBranch() {
            return branch;
        }
        
        public long getLastReport() {
            return lastReportDays;
        }
    }
}
