/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.web.action;

import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.netbeans.modules.exceptions.entity.PackageMapping;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
public class PackageMappingAction extends ExceptionsAbstractAction {

    /* forward name="success" path="" */
    private final static String SUCCESS = "success";
    static final Logger LOG = Logger.getLogger(PackageMappingAction.class.getName());

    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        LOG.log(Level.FINE, "{0}.execute()", SourceJarMappingAction.class.getName());
        List<String> errors = new ArrayList<> ();
        EntityManager em = getEntityManager(request);
        final String drop = request.getParameter("drop");
        if (drop != null) {
            Query query = em.createNamedQuery("PackageMapping.findByPackage1");
            query.setParameter("package1", (Object) drop);
            try {
                Object removed = query.getSingleResult();
                em.getTransaction().begin();
                em.remove(removed);
                em.getTransaction().commit();
            } catch (NoResultException exc) {
                errors.add(exc.getMessage());
            }
        } else {
            String pkg = request.getParameter("package");
            String product = request.getParameter("product");
            String component = request.getParameter("component");
            String subcomponent = request.getParameter("subcomponent");
            
            if (pkg != null) {
                try {
                    PackageMapping m = new PackageMapping(pkg);
                    m.setProduct(Integer.valueOf(product));
                    m.setComponent(component);
                    m.setSubcomponent(subcomponent);
                    em.getTransaction().begin();
                    em.merge(m);
                    em.getTransaction().commit();
                } catch (Exception e) {
                        errors.add(pkg + " " + e.getMessage());
                } 
            }
//            SourcejarMappingBean smb = (SourcejarMappingBean) form;
//            if (smb == null || smb.isClean()) {
//                return mapping.getInputForward();
//            }
//            SourcejarMapping mapp = new SourcejarMapping(smb.getSourcejar().toLowerCase());
//            mapp.setComponent(smb.getComponent().toLowerCase());
//            mapp.setSubcomponent(smb.getSubcomponent());
//            em.getTransaction().begin();
//            em.persist(mapp);
//            em.getTransaction().commit();
//            smb.reset();
        }
        
        final String text = request.getParameter("text");
        if (text != null && text.length() > 0) {
            String[] lines = text.split("\\r?\\n");
            for (int i = 0; i < lines.length; i++) {
                System.out.println("*** " + lines[i]);
                String[] parts = lines[i].split("\\s+");
                if (parts.length == 4) {
                    try {
                        PackageMapping m = new PackageMapping(parts[0]);
                        m.setProduct(Integer.valueOf(parts[1]));
                        m.setComponent(convertNulls(parts[2]));
                        m.setSubcomponent(convertNulls(parts[3]));
                        em.getTransaction().begin();
                        em.merge(m);
                    } catch (Exception e) {
                        errors.add(parts[0] + " " + e.getMessage());
                        e.printStackTrace();
                    } 
                    try {
                        em.getTransaction().commit();
                    } catch (Exception e) {
                        errors.add(parts[0] + " " + e.getMessage());
                        e.printStackTrace();
                    }
                }
            }
        }
        
        final String editable = request.getParameter("editable");
        request.setAttribute("editable", editable);
        
        Query q = em.createNamedQuery("PackageMapping.findAll");
        request.setAttribute("mappings", q.getResultList());
        request.setAttribute("errors", errors);
//        Matcher.getDefault().reload();
        return mapping.findForward(SUCCESS);
    }

    // NULL strings in DB can be returned as "NULL", this method converts
    // them to correct null form.
    private String convertNulls(String input) {
        if (input == null ||
                "NULL".equals(input.toUpperCase())) {
            return null;
        } else {
            return input;
        }
    }
}
