/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.web.ws;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import org.netbeans.server.uihandler.api.bugs.BugReporterFactory;
import org.netbeans.modules.exceptions.utils.PersistenceUtils;
import org.netbeans.server.uihandler.api.Issue;
import org.netbeans.server.uihandler.api.bugs.BugConnector;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
@Path("components")
public class ComponentsService {
    
    @GET
    @Path("products")
    @Produces(MediaType.APPLICATION_JSON)
    public Map<Integer, String> products() {
        BugConnector bc = BugReporterFactory.getBugConnector();
        return bc.getProducts();
    }
    
    @GET
    @Path("usedproducts")
    @Produces(MediaType.APPLICATION_JSON)
    public Map<Integer, String>  usedProducts() {
        List<Integer> l = PersistenceUtils.getInstance().executeQuery("select distinct r.product from Report r", null);
        Map<Integer, String> all = BugReporterFactory.getBugConnector().getProducts();
        Map<Integer, String> result = new LinkedHashMap<> ();
        for (Integer prodId : l) {
            String name = all.get(prodId);
            result.put(prodId, name);
        }
        return result;
    }
    
    @GET
    @Path("components/{productId}")
    @Produces(MediaType.APPLICATION_JSON)
    public Map<String, String> components(@PathParam("productId") final Integer productId) {
        BugConnector bc = BugReporterFactory.getBugConnector();
        return bc.getComponentsForProduct(productId);
    }
    
    @GET
    @Path("subcomponents/{productId}/{component}")
    @Produces(MediaType.APPLICATION_JSON)
    public Map<String, String> subcomponents(@PathParam("productId") final Integer productId,
                                                @PathParam("component") final String component) {
        BugConnector bc = BugReporterFactory.getBugConnector();
        return bc.getSubcomponents(productId, component);
    }
    
    @GET
    @Path("bug/{bugId}")
    @Produces(MediaType.APPLICATION_JSON)
    public Issue bug(@PathParam("bugId") final Integer bugId) {
        BugConnector bc = BugReporterFactory.getBugConnector();
        return bc.getIssue(bugId);
    }
    
    @POST
    @Path("bugComponent/{bugId}/{reportId}")
    @Produces(MediaType.TEXT_PLAIN)
    @Consumes(MediaType.APPLICATION_FORM_URLENCODED)
    public String comment(
            @PathParam("bugId") final String bugId,
            @PathParam("component") final String component) {
        return "";
    }
    
    
}
