/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.web.ws;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import org.netbeans.modules.exceptions.entity.Report;
import org.netbeans.modules.exceptions.entity.Submit;
import org.netbeans.modules.exceptions.utils.PersistenceUtils;
import org.netbeans.server.utils.Persistable;

/**
 *
 * @author Jan Horvath <jhorvath@netbeans.org>
 */
@Path("duplicates")
public class DuplicatesService {

    @GET
    @Path("report/{reportId}")
    @Produces(MediaType.APPLICATION_JSON)
    public List<Duplicate> duplicates(@PathParam("reportId") final Integer reportId) {
        final List<Duplicate> result = new ArrayList<>();
        PersistenceUtils.processPersistable(new Persistable.Query() {
            public Persistable.TransactionResult runQuery(EntityManager em) throws Exception {
                Report r = em.find(Report.class, reportId);
                for (Submit submit : r.getSubmitCollection()) {

                    result.add(new Duplicate(submit.getId(), submit.getBuild(), submit.getBuildId().getVersion(), submit.getMessage()));
                }
                return Persistable.TransactionResult.NONE;
            }
        });
        return result;
    }

    public static class Duplicate {

        public Integer id;
        public Long build;
        public String version;
        public String message;

        public Duplicate(Integer id, Long build, String version, String message) {
            this.id = id;
            this.build = build;
            this.version = version;
            this.message = message;
        }
    }
}
