/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2010 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Sun Microsystems, Inc.
 */
package org.netbeans.web.mail;

import java.io.File;
import javax.persistence.EntityManager;
import org.junit.Test;
import org.netbeans.server.uihandler.DatabaseTestCase;
import org.netbeans.server.uihandler.LogsManagerTest;

/**
 *
 * @author Jindrich Sedek
 */
public class BugsNoWatchDogTest extends DatabaseTestCase {
    
    private String EXCEPTION_DETAIL = "http://statistics.netbeans.org/analytics/detail.do?id=";

    public BugsNoWatchDogTest(String name) {
        super(name);
    }

    @Test
    public void testPrepareMessage() throws Exception {
        EntityManager em = perUtils.createEntityManager();
        em.getTransaction().begin();
        String result = new BugsNoWatchDog().prepareMessage(em, 1);
        assertFalse(result.contains(EXCEPTION_DETAIL));
        
        File log = LogsManagerTest.extractResourceAs(data, "2.log", "NB2040811605.0");
        waitLog(log, "192.168.1.1");
        log = LogsManagerTest.extractResourceAs(data, "2.log", "NB2040811605.1");
        waitLog(log, "192.168.1.1");
        log = LogsManagerTest.extractResourceAs(data, "2.log", "NB2040811605.2");
        waitLog(log, "192.168.1.1");
        log = LogsManagerTest.extractResourceAs(data, "2.log", "NB2040811605.3");
        waitLog(log, "192.168.1.1");

        result = new BugsNoWatchDog().prepareMessage(em, 3);
        assertTrue(result.contains(EXCEPTION_DETAIL));

        result = new BugsNoWatchDog().prepareMessage(em, 5);
        assertFalse(result.contains(EXCEPTION_DETAIL));

        
        em.getTransaction().commit();
        em.close(); 
   }


}

