/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.lib.jmi.xmi;

import java.util.*;
import javax.jmi.reflect.*;
import javax.jmi.model.*;

import org.w3c.dom.*;

import org.netbeans.api.mdr.*;

import org.netbeans.lib.jmi.util.*;

/**
 *
 * @author  msedliak
 * @version
 */
public abstract class XmiMofUtils extends XmiUtils implements XmiConstants {



    /** Creates new BootReaderUtils */
    public XmiMofUtils() {
    }

    public static StructuralFeature getMetaFeature(String attributeName, RefClass proxyClass) {
        StructuralFeature result = null;
        Object metaObject = null;
        MofClass metaProxyClass = (MofClass)proxyClass.refMetaObject();
        try {
            metaObject = metaProxyClass.lookupElementExtended( getShortName( attributeName ) );
            if ( metaObject instanceof StructuralFeature ) result = (StructuralFeature)metaObject;
        } catch (javax.jmi.model.NameNotFoundException e) {
            //Logger.getDefault().log("Feature not found : "+attributeName);
        }
        return result;
    }

    public static void showAllAttributes(Collection attributes) {
        Logger.getDefault().log("Attributes - length : "+ attributes.size());
        for (Iterator it = attributes.iterator(); it.hasNext(); ) {
            Object att = it.next();
            if (att instanceof ModelElement)
                Logger.getDefault().log("Attributes : "+((ModelElement)att).getName()  );
            else
                if (att != null) 
                    Logger.getDefault().log("Attributes : "+att + " - of class : " +att.getClass() );
                else
                    Logger.getDefault().log("Attributes : NULLLLLLLLL " );
        }
    }

    public static String showCollectionAsString(Collection attributes, String separator) {
        String message = null;
        for (Iterator it = attributes.iterator(); it.hasNext(); ) {
            Object att = it.next();
            message = message+separator+message;
        }
        message = message.substring( message.indexOf( separator )+separator.length() );
        return message;
    }

    public static Collection getAllSupertypesContainedObjects(RefClass proxyClass) {
        ArrayList result = new ArrayList();
        ArrayList allContainedObjects = new ArrayList();
        MofClass metaProxyClass = (MofClass)proxyClass.refMetaObject();
        List superClasses = metaProxyClass.allSupertypes();
        Namespace namespace = null;
        for (Iterator it = superClasses.iterator(); it.hasNext(); ) {
            namespace = (Namespace)it.next();
            allContainedObjects.addAll( namespace.getContents() );
        }
        allContainedObjects.addAll( metaProxyClass.getContents() );;
        for (Iterator it = allContainedObjects.iterator(); it.hasNext(); ) {
            RefObject refObject = (RefObject)it.next();
            if ( (refObject instanceof Attribute) && ( !((Attribute)refObject).isDerived() ) ) result.add( refObject );
        }
        allContainedObjects.clear();
        allContainedObjects = null;
        return result;
    }

    public static Reference getReferenceMetaFeature(String referenceNodeName, RefClass proxyClass) {
        Reference result = null;
        StructuralFeature metaFeature = getMetaFeature(referenceNodeName, proxyClass);
        if (metaFeature instanceof Reference) result = (Reference)metaFeature;
        return result;
    }

    public static Attribute getAttributeMetaFeature(String referenceNodeName, RefClass proxyClass) {
        Attribute result = null;
        StructuralFeature metaFeature = getMetaFeature(referenceNodeName, proxyClass);
        if (metaFeature instanceof Attribute) result = (Attribute)metaFeature;
        return result;
    }
}
