/*
 * DeckTest.java
 * JUnit based test
 *
 * Created on December 11, 2006, 11:55 AM
 */

package org.netbeans.examples.cards.api;

import junit.framework.*;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import org.netbeans.examples.cards.api.Pile.VisibilityPolicy;

/**
 *
 * @author Tim
 */
public class DeckTest extends TestCase {
    
    public DeckTest(String testName) {
        super(testName);
    }

    Deck deck;
    @Override
    protected void setUp() throws Exception {
        deck = new Deck (0);
    }

    public void testGetCards() {
        assertEquals (13 * 4, deck.getCards().size());
    }

    public void testCreatePile() {
        Pile pile = deck.createPile(VisibilityPolicy.ALL_VISIBLE, 
                Collections.singleton(deck.getCard(Rank.JACK, Suits.CLUBS)));
        assertEquals (1, pile.size());
        assertEquals (deck.getCard(Rank.JACK, Suits.CLUBS), 
                pile.getCards().iterator().next());
        pile.removeTopCard();
        assertTrue (pile.isEmpty());
    }

    public void testDeal() {
        List <Pile> hands = new ArrayList <Pile> ();
        deck.deal(hands, 2, 5, VisibilityPolicy.NO_CARDS_VISIBLE);
        assertEquals (2, hands.size());
        for (Pile hand : hands) {
            assertEquals (5, hand.size());
        }
        System.err.println("Got hands: " + hands);
    }
}
