package org.netbeans.modules.manifesteditor.editor;

import java.io.IOException;
import org.netbeans.modules.manifesteditor.*;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataNode;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.MultiDataObject;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.Lookup;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;

public class ManifestDataObject extends MultiDataObject implements Lookup.Provider {
    
    final InstanceContent ic;
    private AbstractLookup lookup;
    
    public ManifestDataObject(FileObject pf, ManifestDataLoader loader) throws DataObjectExistsException, IOException {
        super(pf, loader);
        
        ic = new InstanceContent();
        lookup = new AbstractLookup(ic);
        ic.add(ManifestEditorSupport.create(this));
        ic.add(this);
    }
    
    protected Node createNodeDelegate() {
        DataNode n = new DataNode(this, Children.LEAF);
        n.setIconBaseWithExtension("org/netbeans/modules/manifesteditorsupport/manifest.png");
        return n;
    }
    
    public Lookup getLookup() {
        return lookup;
    }
    
    public Node.Cookie getCookie(Class type) {
        Object o = lookup.lookup(type);
        return o instanceof Node.Cookie ? (Node.Cookie)o : null;
    }
    
}
