/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2008 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.examples.nbtidyintegration;

import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.view.ListView;
import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.windows.IOProvider;
import org.openide.windows.InputOutput;
import org.openide.windows.OutputWriter;

public final class TidyConvertVisualPanel2_1 extends JPanel implements ExplorerManager.Provider {

    private final ExplorerManager manager = new ExplorerManager();

    /** Creates new form TidyConvertVisualPanel2 */
    public TidyConvertVisualPanel2_1() {
        initComponents();


    }

    public String getName() {
        return NbBundle.getMessage(getClass(), "CTL_TidyConversionWizardStep2");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        fileScrollList = new ListView();
        fileLabel = new javax.swing.JLabel();

        org.openide.awt.Mnemonics.setLocalizedText(fileLabel, "Files to convert:");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(fileLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(fileScrollList, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 374, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(fileScrollList, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)
                    .add(fileLabel))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel fileLabel;
    private javax.swing.JScrollPane fileScrollList;
    // End of variables declaration//GEN-END:variables

    public ExplorerManager getExplorerManager() {
        return manager;
    }

    public void setFiles(final org.openide.nodes.Node[] fileNodes) {

        CArray nodeArray = new CArray(fileNodes);

        manager.setRootContext(new AbstractNode(nodeArray));


    }

    private class CArray extends Children.Keys implements ChangeListener {

        Node[] fileNodes = null;

        CArray(final Node[] fileNodes) {
            this.fileNodes = fileNodes;
        }

        protected Node[] createNodes(Object object) {
            Node tnode = (Node) object;
            return new Node[]{new FilterNode(tnode)};
        }

        protected void addNotify() {
            setKeys(fileNodes);
        }

        public void stateChanged(ChangeEvent e) {
            InputOutput io = IOProvider.getDefault().getIO(
                    NbBundle.getMessage(getClass(), "TidyOutputTabLabel"), false);
            io.select(); //Tree tab is selected
            OutputWriter writer = io.getOut();
            writer.println("state changed:");
        }
    }
//public void setFiles(Node[] nodes)
//    {
//        DefaultListModel model = new DefaultListModel();
//
//        for (int i =0; i<nodes.length; i++)
//        {
//            model.addElement(nodes[i]);
//        }
//        fileList.setModel(model);
//        fileList.setCellRenderer(new NodeCellRenderer());
//    }
//
//    private class NodeCellRenderer extends DefaultListCellRenderer
//    {
//        NodeCellRenderer()
//        {
//            super();
//        }
//
//        public Component getListCellRendererComponent(JList list,
//                Object value,
//                int index,
//                boolean isSelected,
//                boolean cellHasFocus)
//        {
//            super.getListCellRendererComponent(list,value,index,isSelected,cellHasFocus);
//            Node node = (Node)value;
//            setText((node).getDisplayName());
//            DataObject dataObject =  (DataObject)node.getCookie(DataObject.class);
//            FileObject fileObject = dataObject.getPrimaryFile();
//            File file = FileUtil.toFile(fileObject);
//            setToolTipText(file.getAbsolutePath());
//            setIcon(new ImageIcon(node.getIcon(BeanInfo.ICON_COLOR_16x16)));
//            return this;
//
//        }
//
//    }
//*
}

