/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package pluginportal;

import com.sun.rave.web.ui.appbase.AbstractApplicationBean;
import com.sun.webui.jsf.model.Option;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import javax.faces.FacesException;
import javax.faces.context.FacesContext;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import org.netbeans.pluginportal.system.DisplayCategory;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.PluginSystem;
import org.netbeans.pluginportal.system.impl.PluginSystemFacade;

/**
 * <p>Application scope data bean for your application.  Create properties
 *  here to represent cached data that should be made available to all users
 *  and pages in the application.</p>
 *
 * <p>An instance of this class will be created for you automatically,
 * the first time your application evaluates a value binding expression
 * or method binding expression that references a managed bean using
 * this class.</p>
 *
 *  @author David Botterill
 */
public class ApplicationBean1 extends AbstractApplicationBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
    }
    // </editor-fold>
    @PersistenceUnit(name="jdbc/pluginportal")
    private EntityManagerFactory emf;
    /**
     * <p>Construct a new application data bean instance.</p>
     */
    public ApplicationBean1() {
    }
    
    /**
     * <p>This method is called when this bean is initially added to
     * application scope.  Typically, this occurs as a result of evaluating
     * a value binding or method binding expression, which utilizes the
     * managed bean facility to instantiate this bean and store it into
     * application scope.</p>
     *
     * <p>You may customize this method to initialize and cache application wide
     * data values (such as the lists of valid options for dropdown list
     * components), or to allocate resources that are required for the
     * lifetime of the application.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("ApplicationBean1 Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        
        /**
         * Create the plugin system.
         *
         * For now we need to pass the request as a nb.org login hack.
         */
        HttpServletRequest request = (HttpServletRequest)getExternalContext().getRequest();
        pluginSystem = new PluginSystemFacade(emf,request);
        
        /**
         * Create DisplayCategory option list and map. We'll use the option list
         * for dropdowns.  The select value has to be the string value so we can
         * set it to the value from the NBM deployment descriptor.  We also need a map
         * to get the id for the category back for creating a new Plugin.
         *
         * When we modify the plugin, we'll need to get from the id to the description so we'll need a
         * map with the id as the key also.
         */
        
        setDisplayCategoryMapByName(new HashMap());
        setDisplayCategoryMapById(new HashMap());
        DisplayCategory [] categories = pluginSystem.getDisplayCategories();
        if(null != categories) {
            ArrayList<Option> optionList = new ArrayList();
            Option currentOption = null;
            /**
             * Add a default to the top of the list.
             */
            currentOption = new Option("notselected","--- Select a Display Category ---");
            optionList.add(currentOption);
            for(int ii=0; null != categories && ii < categories.length;ii++) {
                currentOption = new Option(categories[ii].getDisplaycategory_name(),categories[ii].getDisplaycategory_name());
                optionList.add(currentOption);
                getDisplayCategoryMapByName().put(categories[ii].getDisplaycategory_name(),new Integer(categories[ii].getId()));
                getDisplayCategoryMapById().put(new Integer(categories[ii].getId()),categories[ii].getDisplaycategory_name());
            }
            Option [] options = (Option [])optionList.toArray(new Option[0]);
            
        }
    }
    
    
    
    /**
     * <p>This method is called when this bean is removed from
     * application scope.  Typically, this occurs as a result of
     * the application being shut down by its owning container.</p>
     *
     * <p>You may customize this method to clean up resources allocated
     * during the execution of the <code>init()</code> method, or
     * at any later time during the lifetime of the application.</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return an appropriate character encoding based on the
     * <code>Locale</code> defined for the current JavaServer Faces
     * view.  If no more suitable encoding can be found, return
     * "UTF-8" as a general purpose default.</p>
     *
     * <p>The default implementation uses the implementation from
     * our superclass, <code>AbstractApplicationBean</code>.</p>
     */
    public String getLocaleCharacterEncoding() {
        return super.getLocaleCharacterEncoding();
    }
    
    /**
     * Holds value of property pluginSystem.
     */
    private PluginSystem pluginSystem;
    
    /**
     * Getter for property pluginSystem.
     * @return Value of property pluginSystem.
     */
    public PluginSystem getPluginSystem() {
        return this.pluginSystem;
    }
    
    
    /**
     * Holds value of property displayCategoryMapByName.
     */
    private HashMap displayCategoryMapByName;
    
    /**
     * Getter for property displayCategoryMap.
     * @return Value of property displayCategoryMap.
     */
    public HashMap getDisplayCategoryMapByName() {
        return this.displayCategoryMapByName;
    }
    
    /**
     * Setter for property displayCategoryMap.
     * @param displayCategoryMap New value of property displayCategoryMap.
     */
    public void setDisplayCategoryMapByName(HashMap displayCategoryMapByName) {
        this.displayCategoryMapByName = displayCategoryMapByName;
    }
    
    /**
     * Holds value of property displayCategoryMapById.
     */
    private HashMap displayCategoryMapById;
    
    /**
     * Getter for property displayCategoryMapById.
     * @return Value of property displayCategoryMapById.
     */
    public HashMap getDisplayCategoryMapById() {
        return this.displayCategoryMapById;
    }
    
    /**
     * Setter for property displayCategoryMapById.
     * @param displayCategoryMapById New value of property displayCategoryMapById.
     */
    public void setDisplayCategoryMapById(HashMap displayCategoryMapById) {
        this.displayCategoryMapById = displayCategoryMapById;
    }
    
    /**
     * Holds value of property featurePlugin.
     */
    private Plugin featurePlugin;
    
    /**
     * Getter for property featurePlugin.
     * @return Value of property featurePlugin.
     */
    public Plugin getFeaturePlugin() {
        if(null == getPluginSystem()) {
            return null;
        }
        String configFile = FacesContext.getCurrentInstance().getExternalContext().getInitParameter("org.netbeans.pluginportal.config");
        ServletContext theApplicationsServletContext = (ServletContext) this.getExternalContext().getContext();
        String realPath = theApplicationsServletContext.getRealPath(configFile);
        if(null != configFile && !configFile.equals("")) {
            Properties configProps = new Properties();
            try {
                FileInputStream fis = new FileInputStream(new File(realPath));
                configProps.load(fis);
                fis.close();
            } catch (FileNotFoundException ex) {
                log("Error loading config file: FileNotFoundException=" + ex.getMessage());
                return null;
            } catch (IOException ex) {
                log("Error loading config file: IOException=" + ex.getMessage());
                return null;
            }
            String featurePluginId = configProps.getProperty("featured_plugin");
            if(null != featurePluginId) {
                featurePlugin =  getPluginSystem().getPlugin(new Long(featurePluginId));
            }
        }
        
        /**
         * make sure we don't have a null average rating for the featured plugin since it will show as a half
         * a star instead of no stars.
         */
        if(null != featurePlugin  && null == featurePlugin.getAverage_rating()) {
            featurePlugin.setAverage_rating(new Double(0.0));
        }
        
        return this.featurePlugin;
    }
    
    /**
     * Setter for property featurePlugin.
     * @param featurePlugin New value of property featurePlugin.
     */
    public void setFeaturePlugin(Plugin featurePlugin) {
        this.featurePlugin = featurePlugin;
    }
    
    /**
     * Holds value of property normalRatingText.
     */
    private String normalRatingText="Rating:";
    
    /**
     * Getter for property normalRatingText.
     * @return Value of property normalRatingText.
     */
    public String getNormalRatingText() {
        return this.normalRatingText;
    }
    
    /**
     * Setter for property normalRatingText.
     * @param normalRatingText New value of property normalRatingText.
     */
    public void setNormalRatingText(String normalRatingText) {
        this.normalRatingText = normalRatingText;
    }
    
    /**
     * Holds value of property featuredPluginAvgRatingText.
     */
    private String featuredPluginAvgRatingText;
    
    /**
     * Getter for property featuredPluginAvgRatingText.
     * @return Value of property featuredPluginAvgRatingText.
     */
    public String getFeaturedPluginAvgRatingText() {
        if(null == getFeaturePlugin()) {
            return null;
        }
        int numUsers = 0;
        if(null !=  getFeaturePlugin().getRatings()) {
            numUsers=getFeaturePlugin().getRatings().size();
        }
        setFeaturedPluginAvgRatingText("Rated by " +numUsers + " users.");
        return this.featuredPluginAvgRatingText;
    }
    
    /**
     * Setter for property featuredPluginAvgRatingText.
     * @param featuredPluginAvgRatingText New value of property featuredPluginAvgRatingText.
     */
    public void setFeaturedPluginAvgRatingText(String featuredPluginAvgRatingText) {
        this.featuredPluginAvgRatingText = featuredPluginAvgRatingText;
    }
    
    /**
     * Holds value of property news.
     */
    private String news;
    
    /**
     * Getter for property news.
     * @return Value of property news.
     */
    public String getNews() {
        String newsFile = FacesContext.getCurrentInstance().getExternalContext().getInitParameter("org.netbeans.pluginportal.news");
        ServletContext theApplicationsServletContext = (ServletContext) this.getExternalContext().getContext();
        String realPath = theApplicationsServletContext.getRealPath(newsFile);
        news="";
        if(null != newsFile && !newsFile.equals("")) {
            
            try {
                BufferedReader reader = new BufferedReader(new FileReader(new File(realPath)));
                String currentLine = null;
                
                while((null != (currentLine = reader.readLine()))) {
                    news += currentLine+"\n";
                }
                reader.close();
                
            } catch (FileNotFoundException ex) {
                log("Error loading news file: FileNotFoundException=" + ex.getMessage());
                return null;
            } catch (IOException ex) {
                log("Error loading news file: IOException=" + ex.getMessage());
                return null;
            }

        }
        
        /**
         * make sure we don't have a null average rating for the featured plugin since it will show as a half
         * a star instead of no stars.
         */
        if(null != featurePlugin  && null == featurePlugin.getAverage_rating()) {
            featurePlugin.setAverage_rating(new Double(0.0));
        }
        
        return this.news;
    }
    
    /**
     * Setter for property news.
     * @param news New value of property news.
     */
    public void setNews(String news) {
        this.news = news;
    }
    
    
    
    
}
