/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.system.impl;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;
import org.netbeans.pluginportal.data.PluginImpl;
import org.netbeans.pluginportal.system.CategoryCount;
import org.netbeans.pluginportal.system.Plugin;

/**
 *
 * @author David Botterill
 */
public class RecentlyAddedCache extends AbstractCache {
    private java.util.ArrayList<Plugin> recentlyAdded;
    private EntityManagerFactory emf;
    
    /**
     * Creates a new instance of RecentlyAddedCache
     */
    public RecentlyAddedCache() {
    }
    public RecentlyAddedCache(EntityManagerFactory inEmf) {
        emf=inEmf;
        loadList();
    }
    
    
    /**
     * Getter for property recentlyAdded.
     * 
     * @return Value of property recentlyAdded.
     */
    public java.util.ArrayList<Plugin> getRecentlyAdded() {
        return this.recentlyAdded;
    }
    
    /**
     * Setter for property recentlyAdded.
     * 
     * @param recentlyAdded New value of property recentlyAdded.
     */
    public void setRecentlyAdded(java.util.ArrayList<Plugin> recentlyAdded) {
        this.recentlyAdded = recentlyAdded;
    }
    
    protected synchronized void loadList() {
        EntityManager em = emf.createEntityManager();
        /**
         * Figure out the current date + 30 days
         */
        Calendar pastDate = GregorianCalendar.getInstance();
        pastDate.add(Calendar.DAY_OF_YEAR,-30);
        Date tempDate = pastDate.getTime();
        java.sql.Date queryDate = new java.sql.Date(tempDate.getTime());
        
        String select = "select p from PluginImpl p order by p.date_added desc,p.plugin_name";
        Query query = em.createQuery(select);
        List<PluginImpl> resultList = query.getResultList();
        
        ArrayList<Plugin> newCache = new ArrayList(resultList);
        
        setRecentlyAdded(newCache);
    }
    
}
