/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.options;

import org.netbeans.testspeceditor.xmlizable.XMLizable;

/**
 *
 * @author ehucka
 */
public class DividerLocations implements XMLizable {
    
    private double main;
    private double testspec1;
    private double case1;
    private double case2;
    private double suite1;
    private double suite2;
    private double suite3;
    private double action1;
    private double action2;
    
     
    public DividerLocations() {
        setMain(0.36);
        setTestspec1(0.2);
        setCase1(0.2);
        setCase2(0.2);
        setSuite1(0.16);
        setSuite2(0.18);
        setSuite3(0.18);
        setAction1(0.5);
        setAction2(0.25);
    }
    
    public double getMain() {
        return main;
    }
    
    public void setMain(double value) {
        if (value >= 0.0) this.main = value;
    }
    
    public double getTestspec1() {
        return testspec1;
    }
    
    public void setTestspec1(double value) {
        if (value >= 0.0) this.testspec1 = value;
    }
    
    public double getCase1() {
        return case1;
    }
    
    public void setCase1(double value) {
        if (value >= 0.0) this.case1 = value;
    }
    
    public double getCase2() {
        return case2;
    }
    
    public void setCase2(double value) {
        if (value >= 0.0) if (value >= 0.0) this.case2 = value;
    }
    
    public double getSuite1() {
        return suite1;
    }
    
    public void setSuite1(double value) {
        if (value >= 0.0) this.suite1 = value;
    }
    
    public double getSuite2() {
        return suite2;
    }
    
    public void setSuite2(double value) {
        if (value >= 0.0) this.suite2 = value;
    }
    
    public double getSuite3() {
        return suite3;
    }
    
    public void setSuite3(double value) {
        if (value >= 0.0) this.suite3 = value;
    }
    
    public double getAction1() {
        return action1;
    }
    
    public void setAction1(double value) {
        if (value >= 0.0) this.action1 = value;
    }
    
    public double getAction2() {
        return action2;
    }
    
    public void setAction2(double value) {
        if (value >= 0.0) this.action2 = value;
    }
    
}
