/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted;

/**
 *
 * @author  Petr Slegr
 * @version 22.04.02
 */
public abstract class AutomatonPaintPolicy {
    
    public static final int MODE_EXACT = 0;
    
    public static final int MODE_START = 1;
    
    public static final int MODE_END = 2;
    
    public static final AutomatonPaintPolicy DEFAULT = new DefaultPolicy ();
    
    /** Creates a new instance of AutomatonPaintingPolicy */
    public AutomatonPaintPolicy () {
    }
    
    public abstract PaintDescriptor[] getPolicy ();
    
    public abstract int getMode ();
    
    ////////////////////////////////////////////////////////////////////////////
    private static class DefaultPolicy extends AutomatonPaintPolicy {
        
        public int getMode () {
            return MODE_END;
        }
        
        public PaintDescriptor[] getPolicy () {
            //PaintDescriptor pd1 = new PaintDescriptor (VisualAutomatonNode.class, 0);
            PaintDescriptor pd2 = new PaintDescriptor (null, PaintDescriptor.SELECTED);
            return new PaintDescriptor[] { pd2 };
        }
        
    }
    
    // for debug
    static class TestPolicy extends AutomatonPaintPolicy {
        
        public int getMode () {
            return MODE_END;
        }
        
        public PaintDescriptor[] getPolicy () {
            PaintDescriptor pd1 = new PaintDescriptor (null, PaintDescriptor.SELECTED);
            PaintDescriptor pd2 = new PaintDescriptor (null, PaintDescriptor.ERROR);
            return new PaintDescriptor[] { pd1, pd2 };
        }
        
    }
    
}
