/*
                    Sun Public License Notice
 
The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/
 
The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.
 
Contributor(s): Petr Slegr.
 */

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import java.awt.Dimension;
import javax.swing.JFrame;
import org.netbeans.modules.regsup.util.Util;
import org.netbeans.modules.regsup.debug.RexDebugger;

/**
 *
 * @author  Petr Slegr
 */
public class OpenContainerAction extends ElementAction implements DebuggingAction {
    
    public void performAction (VisualAutomatonElement[] selected) {
        // respects if debugger is running
        VisualAutomatonContainer container = (VisualAutomatonContainer) selected[0];
        AutomatonEditorPanel editorPanel = MainManager.getDefault ().getCurrentPanel ();
        RexDebugger debugger = editorPanel.getCurrentView ().getDebugger ();
        AutomatonPanel nextPanel = AutomatonPanel.createFor (container, debugger);
        editorPanel.changeViewTo (nextPanel);
    }
    
    
    public String getName () {
        return NbBundle.getMessage (this.getClass (), "CTL_OPEN_CONTAINER_ACTION");
    }
    
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        /*
        if (selected.length != 1) {
            return false;
        }
        if (! (selected[0] instanceof VisualAutomatonContainer)) {
            return false;
        }
        if (MainManager.getDefault ().getCurrentWindow () == null) {
            return false;
            // !!!??? co kdyz to nekdo mezi volanim isEnabled a perform zmeni ???
        }
        boolean b = ! Util.containsTopLevelContainer (selected);
        return b;
         */
        //return false;
        if (selected.length != 1) {
            return false;
        }
        if (! (selected[0] instanceof VisualAutomatonContainer)) {
            return false;
        }
        return true;
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
