/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import org.netbeans.modules.regsup.logic.*;
import java.awt.Point;

/** Reverts edge (A -> B changes to B -> A)
 *
 * @author  Petr Slegr
 */
// !!!! causes NPE of self-edge
// !!!! should create compound undo edit
public class RevertEdgeAction extends ElementAction {

    public void performAction (VisualAutomatonElement[] selected) {
        VisualAutomatonEdge edge = (VisualAutomatonEdge) selected[0];
        VisualAutomatonNode source = edge.getSourceNode ();
        VisualAutomatonNode target = edge.getTargetNode ();
        VisualAutomatonContainer container = edge.getContainer ();
        AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
        container.createEdge (target, source, edge.getEdgeValue ());
        container.removeElement (edge);
        //editor.resetSelectedElements ();
    } 

    public String getName () {
        //return NbBundle.getMessage (CreateEdgeAction.class, "CTL_CREATE_EDGE_ACTION");
        return "Revert edge";
    }

    protected String iconResource () {
        return "ActionIcon.gif";
    }

    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }

    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        if (selected.length != 1) {
            return false;
        }
        if (! (selected[0] instanceof VisualAutomatonEdge)) {
            return false;
        }
        // !!!!!???? jak rozpoznat selfedge?
        VisualAutomatonEdge edge = (VisualAutomatonEdge) selected[0];
        VisualAutomatonNode source = edge.getSourceNode ();
        VisualAutomatonNode target = edge.getTargetNode ();
        return ! target.hasOutputEdgeTo (source);
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
    }
    */

}
