/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.logic.aut2expr.ResolveResult;
import org.netbeans.modules.regsup.debug.RexDebugger;
import org.netbeans.modules.regsup.auted.*;


/**
 * Action that can always be invoked and work procedurally.
 *
 * @author  Petr Slegr
 * @version 31.03.02
 */
public class StartDebuggerAction extends CallableSystemAction {
    
    public void performAction () {
        /*
        MainManager mm = MainManager.getDefault ();
        AutomatonEditor editor = mm.getCurrentEditor ();
        EditorWindow window = mm.getCurrentWindow ();
        if (! editor.getContent ().getLogicAutomaton ().isResolved ()) {
            window.selectGraph2ExpressionTab ();
            ResolveResult result = window.evaluateAutomaton ();
            if (! result.isOk ()) {
                return;
            }
        }
        RexDebugger debugger = mm.getDefault ().createDebugger (mm.getCurrentEditor ());
        // !!!!!! zrusit
        mm.setCurrentDebugger (debugger);
        window.prepareDebugTab (debugger);
        debugger.start ();
         */
    }
    
    public String getName () {
        return "Start debugger";
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /** Action is enabled if editor for root container is open now.
     */
    public boolean isEnabled () {
        return MainManager.getDefault ().getCurrentEditor ().isForRoot ();
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
