/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import org.netbeans.modules.regsup.logic.*;
import org.netbeans.modules.regsup.util.Util;
import org.netbeans.modules.regsup.debug.RexDebugger;

/**
 *
 * @author  Petr Slegr
 * @version 07.04.02
 */
public class StepOverAction extends ElementAction implements DebuggingAction {
    
    public void performAction (VisualAutomatonElement[] selected) {
        // !!!!??? co kdyz to bude jiny debugger nez pro ktery byla testovana isEnabled ???
        RexDebugger debugger = MainManager.getDefault ().getCurrentDebugger ();
        debugger.stepOver ((VisualAutomatonContainer) selected[0]);
    }
    
    public String getName () {
        return "Step Over";
    }
    
    protected String iconResource () {
        return "ActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }
    
    /**
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        if (selected.length != 1) { // was bug: missing this if
            return false;
        }
        if (! (selected[0] instanceof VisualAutomatonContainer)) {
            return false;
        }
        VisualAutomatonContainer cont = (VisualAutomatonContainer) selected[0];
        RexDebugger debugger = MainManager.getDefault ().getCurrentDebugger ();
        // !!!!???? chtelo by to lepsi test
        if (debugger == null) {
            return false;
        }
        if (! debugger.isStarted ()) {
            return false;
        }
        if (! debugger.getCurrentState ().containsContainer (cont)) {
            return false;
        }
        return true;
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
     * }
     */
    
}
