/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.ui;

import javax.swing.JTextField;
import java.util.ArrayList;
import javax.swing.text.Caret;
import javax.swing.text.DefaultCaret;
import java.awt.Rectangle;
import java.awt.Graphics2D;
import java.awt.Color;
import java.awt.geom.Line2D;
import javax.swing.plaf.TextUI;
import javax.swing.text.BadLocationException;

/**
 *
 * @author  Petr Slegr
 * @version 21.04.02
 */
public class BreakpointableTextField extends JTextField {
    
    private ArrayList breakpoints = new ArrayList ();
    
    /** Creates a new instance of BreakpointableTextField */
    public BreakpointableTextField () {
        //setBackground (new Color (102,255,102));
    }
    
    public void paint (java.awt.Graphics graphics) {
        super.paint (graphics);
        //
        Color oldColor = graphics.getColor ();
        graphics.setColor (Color.red);  // !! const
        TextUI textui = getUI();
        //
        for (int i = 0; i < breakpoints.size (); i++) {
            Integer pos = (Integer) breakpoints.get (i);
            int position = pos.intValue ();
            Rectangle r = null;
            try {
                r = textui.modelToView (this, position);
            }
            catch (BadLocationException e) {
                // !!!!???? osetrovat ????
                e.printStackTrace();
            }
            // !!!!! pri BLE hrozi NPE
            graphics.drawLine (r.x, r.y, r.x, r.y + r.height - 1);        
        }
        graphics.setColor (oldColor);
        getCaret ().paint (graphics);
    }
    
    public void toggleBreakpoint () {
        int position = getCaretPosition ();
        Integer pos = new Integer (position);
        if (breakpoints.contains (pos)) {
            breakpoints.remove (pos);
        } else {
            breakpoints.add (pos);
        }
        repaint ();
        requestFocus ();
    }
    
}
