/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import org.xml.sax.*;
import org.netbeans.modules.regsup.auted.VisualAutomatonContainer;

public interface AutomatonHandler {

    public VisualAutomatonContainer getResult ();
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_source (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_source () throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_container (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_container () throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_edge (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_edge () throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_final (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_nodeId (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_node (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_node () throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_position (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_position () throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_longHumanName (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_target (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_target () throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_content (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_content () throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_humanName (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_y (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_x (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_value (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_starting (final java.lang.String data, final AttributeList meta) throws SAXException;
    
    /**
     * A container element start event handling method.
     * @param meta attributes
     */
    public void start_automaton (final AttributeList meta) throws SAXException;
    
    /**
     * A container element end event handling method.
     */
    public void end_automaton () throws SAXException;
    
    /**
     * A data element event handling method.
     * @param data value or null
     * @param meta attributes
     */
    public void handle_templateName (final java.lang.String data, final AttributeList meta) throws SAXException;
    
}

