/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import org.openide.loaders.*;
import org.openide.nodes.*;
import org.openide.util.NbBundle;

/** A node to represent this object.
 *
 * @author  Petr Slegr
 */
public class RegsupDataNode extends DataNode {
    
    public RegsupDataNode (RegsupDataObject obj) {
        this (obj, Children.LEAF);
    }
    
    public RegsupDataNode (RegsupDataObject obj, Children ch) {
        super (obj, ch);
        setIconBase ("/org/netbeans/modules/regsup/resources/icons/regsup");
    }
    
    protected RegsupDataObject getRegsupDataObject () {
        return (RegsupDataObject) getDataObject ();
    }
    
    /* Example of adding Executor / Debugger / Arguments to node:
    protected Sheet createSheet () {
        Sheet sheet = super.createSheet ();
        Sheet.Set set = sheet.get (ExecSupport.PROP_EXECUTION);
        if (set == null) {
            set = new Sheet.Set ();
            set.setName (ExecSupport.PROP_EXECUTION);
            set.setDisplayName (NbBundle.getMessage (RegsupDataNode.class, "LBL_DataNode_exec_sheet"));
            set.setShortDescription (NbBundle.getMessage (RegsupDataNode.class, "HINT_DataNode_exec_sheet"));
        }
        ((ExecSupport) getCookie (ExecSupport.class)).addProperties (set);
        // Maybe:
        ((CompilerSupport) getCookie (CompilerSupport.class)).addProperties (set);
        sheet.put (set);
        return sheet;
    }
     */
    
    /*
    public SystemAction getDefaultAction () {
        return SystemAction.get (MyFavoriteAction.class);
    }
     */
    
}
