/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

import java.util.*;

/** This class represents a regular (sub)expression that can be used as a value
 * of edge in the automaton, i.e. an expression describing string with length one or an
 * empty string.
 */
// !!! to solve relation between this class and RexAlterElement
public abstract class RexEdgeElement /* extends RexAlterElement */ extends RexElement {
    
    public RexEdgeElement () {
        super ();
    }
 
    public abstract boolean includes (char ch);
    
    public abstract boolean intersects (RexEdgeElement edgeElem);
    
    /** Returns Set of Intervals describing this element
     */
    abstract Set getIntervals ();
    
    /*
    public void add (RexEdgeElement elem) {
        super.add (elem); // was bug: stack overflow without super :-)
    }
     */
    
}
