/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

/**
 *
 * @author  Petr Slegr
 * @version 26.11.01
 */
public class RexEdgeFactory {
    
    /** Creates new RexEdgeFactory */
    public RexEdgeFactory () {
    }
    public static final int UPPER_CASE = 1;
    
    public static final int LOWER_CASE = 2;
    
    public static final int BOTH_CASE = 0;
    
    public static RexEdgeElement createLetter (int mode) {
        ComplexRexEdgeElement elem = new ComplexRexEdgeElement (false);
        if (mode == UPPER_CASE) {
            elem.addInterval ('A', 'Z');
        }
        else if (mode == LOWER_CASE) {
            elem.addInterval ('a', 'z');
        }
        else if (mode == BOTH_CASE) {
            elem.addInterval ('A', 'Z');
            elem.addInterval ('a', 'z');
        } else {
            throw new IllegalArgumentException ("Unknown mode: " + mode);
        }
        return elem;
    }
    
    /**
     */
    public static RexEdgeElement createAlfaNum () {
        ComplexRexEdgeElement elem = new ComplexRexEdgeElement (false);
        elem.addInterval ('a', 'z');
        elem.addInterval ('A', 'Z');
        elem.addSingle ('_');
        return elem;
    }
    
    // !!! testovat string
    public static RexEdgeElement createExcept (String exceps) {
        ComplexRexEdgeElement elem = new ComplexRexEdgeElement (true);
        for (int i=0; i < exceps.length (); i++) {
            // !! duplicity ??
            elem.addSingle (exceps.charAt (i));
        }
        return elem;
    }

    // !!! testovat string
    public static RexEdgeElement createFrom (String from) {
        ComplexRexEdgeElement elem = new ComplexRexEdgeElement (false);
        for (int i=0; i < from.length (); i++) {
            // !! duplicity ??
            elem.addSingle (from.charAt (i));
        }
        return elem;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main (String args[]) {
    }
    
}
