/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic.aut2expr;

import org.netbeans.modules.regsup.logic.*;

/**
 *
 * @author  Petr Slegr
 * @version 02.12.01/2
 */
public class ProxyResolveProblem extends ResolveProblem {
    
    ResolveProblem problem;
    
    CompoundLogicAutomatonNode place;
    
    public ProxyResolveProblem (CompoundLogicAutomatonNode place, ResolveProblem problem) {
        super ();
        this.problem = problem;
        this.place = place;
    }

    public boolean isError () {
        return problem.isError ();
    }
    
    public boolean isLocal () {
        return problem.isLocal ();
    }
    
    public boolean isProxy () {
        return true;
    }
    
    public ResolveProblem getProblem () {
        return problem;
    }
    
    public CompoundLogicAutomatonNode getPlace () {
        return place;
    }
    
    public String toString () {
        StringBuffer buf = new StringBuffer ();
        buf.append ("compound.");
        buf.append (problem.toString ());
        return buf.toString ();
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
    }

}
