<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:java="java">
  <xsl:output method="html" />

<xsl:param name="title">Bug List</xsl:param>
<xsl:template match="issuezilla">
<html>
<head>
  <title><xsl:value-of select="$title" /></title>
</head>
<body>
  <table border="0" cellpadding="1" cellspacing="1">
  <tr>
    <td width="50"><b>ID</b></td>
    <td width="30"><b>Prio</b></td>
    <td width="90"><b>Component</b></td>
    <td width="*"><b>Synopsis</b></td>
  </tr>
  <xsl:apply-templates select="issue">
    <xsl:sort select="component" />
    <xsl:sort data-type="number" select="issue_id" />
  </xsl:apply-templates>
  </table>
  <xsl:value-of select="count(issue)" /> issues found.<br />
  Generated: <xsl:value-of select="java:util.Date.new()" />
</body>
</html>
</xsl:template>

<xsl:template match="issue" xml:space="preserve">
  <tr>
    <td><xsl:text disable-output-escaping="yes">&lt;</xsl:text>a href="http://www.netbeans.org/issues/show_bug.cgi?id=<xsl:value-of select="issue_id" />"<xsl:text disable-output-escaping="yes">&gt;</xsl:text><xsl:value-of select="issue_id" /><xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text></td>
    <td><xsl:value-of select="priority" /></td>
    <td><xsl:value-of select="component" /></td>
    <td><xsl:value-of select="short_desc" /></td>
  </tr>
</xsl:template>

</xsl:stylesheet>











